// Copyright 2006 FoxyTunes
// All Rights Reserved

function foxytunesCompareCharSets(a,b) {
	if (a.getAttribute('label') < b.getAttribute('label')) {
		return -1;
	} else {
		return 1;
	}

}

function foxytunesPopulateCharacterEncodings() {
   var d           = document;
   var popup       = d.getElementById('foxytunes-character-encoding-popup');

   var converterManager = Components.classes["@mozilla.org/charset-converter-manager;1"].getService(Components.interfaces.nsICharsetConverterManager);
   var decoders = converterManager.getDecoderList();

   var i = 0;
   gFoxyTunesAllCharSets = new Array();
   var newElement;
   while (decoders.hasMore()) {
	var charset = decoders.getNext();
	var charsetTitle = '';
	try {
		charsetTitle = converterManager.getCharsetTitle(charset);
	} catch (error) {
        }		

	var charsetName;
	if (charsetTitle == '') {
		charsetName = charset;
	} else {
		charsetName = charsetTitle;
	}
	newElement = d.createElement('menuitem');
	newElement.setAttribute('name', 'foxytunes-all-charsets');
        newElement.setAttribute('label', charsetName);
        newElement.setAttribute('tooltiptext', charsetName);
        newElement.setAttribute('value', charset);
      	newElement.setAttribute('oncommand', 'foxytunesSelectCharset(event)'); 
	gFoxyTunesAllCharSets[i] = newElement; 
	i++;
   }

   gFoxyTunesAllCharSets.sort(foxytunesCompareCharSets);
   for (var i=0; i < gFoxyTunesAllCharSets.length; i++ ) { 
        popup.appendChild(gFoxyTunesAllCharSets[i]);
   }
}

function foxytunesOnPlayerListShowing(event) {
    if (!gFoxyTunesCurrentPlayerClass) return false;

    var playerLabel = '';
    var target = event.target;
    for (var i=0; i < target.childNodes.length; i++) {
        var child = target.childNodes[i];
        if (child.getAttribute('value') == gFoxyTunesCurrentPlayerClass) {
            child.setAttribute('selected', 'true');
            playerLabel = child.getAttribute('label');
        } else {
            child.setAttribute('selected', 'false');
        }
    }

    var configElemSep = document.getElementById('foxytunes-configure-player-menuseparator');
    var configElem = document.getElementById('foxytunes-configure-player-menuitem');

	var player = foxytunesGetPlayerShortNameFromContractID(gFoxyTunesCurrentPlayerClass);
    if (gFTPlayerConfig.needsConfig(player)) {
        configElemSep.hidden = false;
        configElem.hidden = false;
        configElem.setAttribute('label', 
                foxytunesGetLocaleString("configureWithParam", [playerLabel]));
        configElem.setAttribute('tooltip', 
                foxytunesGetLocaleString("configureWithParam", [playerLabel]));
        configElem.setAttribute('playername', player);
    } else {
        configElemSep.hidden = true;
        configElem.hidden = true;
    }

    return true;
}

function foxytunesConfigureCurrentPlayer() {
	var player = foxytunesGetPlayerShortNameFromContractID(gFoxyTunesCurrentPlayerClass);
    gFTPlayerConfig.openConfigDialog(player);
    foxytunesSetPlayerOptions();
}

function foxytunesPopulatePlayers() {
   var d           = document;
   var popup       = d.getElementById('foxytunes-available-player-popup');
   var newElement;
   var iPlayer = 0;
   var playerMenuItems = new Array();
   for (var classContract in Components.classes) {
	var player = foxytunesTryGetFoxyTunesPlayerFromContractID(classContract);
	if (player != null) {
    		newElement = d.createElement('menuitem');
       	 	// newElement.setAttribute('type', 'radio');
       	 	newElement.setAttribute('name', 'foxytunes-player');

            var readableName = gFTPlayerConfig.getReadableName(player.toLowerCase());         
		    newElement.playerName = readableName ? readableName : player;
       	 	newElement.setAttribute('label', newElement.playerName);
	        newElement.setAttribute('tooltiptext', newElement.playerName);
        	newElement.setAttribute('value', classContract);
        	newElement.setAttribute('class', 'menuitem-iconic player-item'); 
        	newElement.setAttribute('playername', player.toLowerCase());
        	newElement.setAttribute('oncommand', 'foxytunesOnSelectPlayer(event)');
		if ((gFoxyTunesCurrentPlayerClass != null) &&
			(gFoxyTunesCurrentPlayerClass == classContract)) {
			// select the user preferred player
        		newElement.setAttribute('selected', 'true');
		} else {
			if ((gFoxyTunesCurrentPlayerClass == null) && 
				(iPlayer == 0)) {
					// select the first available player
					gFoxyTunesCurrentPlayerClass = classContract;	
					foxytunesWritePreferences();
		        	newElement.setAttribute('selected', 'true');
			}
		}
		playerMenuItems.push(newElement);
		iPlayer++;
	}
   }

   var sortFunc = function (a, b) { 	a = a.playerName.toLowerCase(); 
					b = b.playerName.toLowerCase(); 
					if ( a < b ) return 1;
				        if ( a > b ) return -1;
			        	return 0;   }
   playerMenuItems.sort(sortFunc);
   for (var i = 0; i < playerMenuItems.length; i++) {
    if (popup.hasChildNodes()) {
    	popup.insertBefore(playerMenuItems[i], popup.firstChild);
    } else{
    	popup.appendChild(playerMenuItems[i]);
    }
   }
   return iPlayer;
}

// ********* start recent charsets stuff *************
function foxytunesGetCharSetMenuItem(charsetList, charset, clone) {
   for (var i=0; i < charsetList.length; i++) {
	if (charsetList[i].getAttribute('value') == charset) {
                if (clone) {
			return charsetList[i].cloneNode(true);
		} else {
			return charsetList[i];
		}
	}
   }
   return null;
}

// remove an element from the recent list, if too long
function foxytunesTrimRecentCharSets(charSetMenu, groupName) {
   var nRecentEntries = 0;
   var children = charSetMenu.childNodes;
   var removeCandidate;
   for (var i=0; i < children.length; i++) {
       if (children[i].getAttribute('name') == groupName) {
          nRecentEntries++;
          if (nRecentEntries == 2) {
		removeCandidate = children[i]; // always remove the second node (the one after default)
          }
       }
   }
   if (nRecentEntries > gFoxyTunesMaxRecentCharsets) {
	charSetMenu.removeChild(removeCandidate);
   }
}

function foxytunesAddRecentCharSet(charset, checked) {
   var groupName = 'foxytunes-character-encoding-recent';
   var charetRecentMenu = document.getElementById('foxytunes-charsets-recent-menu');
   var recentMenuItem = foxytunesGetCharSetMenuItem(charetRecentMenu.childNodes, charset, false);
   if (recentMenuItem != null) {
	// charset already exists in recent
	if (checked) {
      	     recentMenuItem.setAttribute('checked', 'true');
	}
   } else {
   	// clone item from the "all" list:
   	var newRecentMenuItem = foxytunesGetCharSetMenuItem(gFoxyTunesAllCharSets, charset, true);
        if (newRecentMenuItem == null) {
		dump("\naddRecentCharSet: couldn't find charset: " + charset + "\n");
		return;
	}
 	var charSetRecentSeparator = document.getElementById('foxytunes-charsets-recent-separator');
	newRecentMenuItem.setAttribute('name', groupName);
        newRecentMenuItem.setAttribute('type', 'radio');
      	newRecentMenuItem.setAttribute('oncommand', 'foxytunesSelectCharset(event)'); 
	if (checked) {
      	     newRecentMenuItem.setAttribute('checked', 'true');

	}
	charetRecentMenu.insertBefore(newRecentMenuItem, charSetRecentSeparator);
	foxytunesTrimRecentCharSets(charetRecentMenu, groupName);
   }
}

function foxytunesPopulateRecentCharsets() {
  var charsetArray = gFoxyTunesRecentCharsets.split(', ');

  if (charsetArray.length > 0) {
    for (var i = 0; i < charsetArray.length; i++) {
	var isCurrent = charsetArray[i] == gFoxyTunesCharacterEncoding;
	foxytunesAddRecentCharSet(charsetArray[i], isCurrent);
	if (isCurrent) {
		// we have some other recend charset selected, deselect "default":
		document.getElementById('foxytunes-character-encoding-default').setAttribute('checked', 'false');
	}
    }
  }
}

function foxytunesSelectCharset(event) {
    var item = event.target;
    gFoxyTunesCharacterEncoding = item.getAttribute("value");
    foxytunesAddRecentCharSet(gFoxyTunesCharacterEncoding, true);
    foxytunesWritePreferences();

    // update the player
    foxytunesSetPlayerOptions();

    // update the track display
    foxytunesUpdateTrackTitleAfterCommand();
}

function foxytunesUpdateRecentCharsetsList() {
   var groupName = 'foxytunes-character-encoding-recent';
   var charetRecentMenu = document.getElementById('foxytunes-charsets-recent-menu');
   var children = charetRecentMenu.childNodes;
   gFoxyTunesRecentCharsets = '';
   var nAdded = 0;
   for (var i=0; i < children.length; i++) {
       var charSet = children[i].getAttribute('value');
       if ((children[i].getAttribute('name') == groupName) &&
		(charSet != 'default')) {
                if (nAdded == 0) {
			gFoxyTunesRecentCharsets = charSet;
		} else {
			gFoxyTunesRecentCharsets = gFoxyTunesRecentCharsets + ", " + charSet;
		}
		nAdded++;
       }
   }
}

// ********* end   recent charsets stuff *************

function foxytunesWritePreferences() {
   gbFoxyTunesIgnorePrefChange = true;

   try {
     gFoxyTunesPref.setCharPref("player_class", gFoxyTunesCurrentPlayerClass);
   } 
   catch (err) {
     dump("\nSetting preference for player_class failed: " + err + "\n");
   }
   try {
     gFoxyTunesPref.setCharPref("character_encoding", gFoxyTunesCharacterEncoding);
   } 
   catch (err) {
     dump("\nSetting preference for character_encoding failed: " + err + "\n");
   }

   foxytunesUpdateRecentCharsetsList();
   try {
     gFoxyTunesPref.setCharPref("recent_charsets", gFoxyTunesRecentCharsets);
   } 
   catch (err) {
     dump("\nSetting preference for recent_charsets failed: " + err + "\n");
   }

   try {
     if (gFoxyTunesRecentPlayers) {
         gFoxyTunesPref.setCharPref("recent_players", gFoxyTunesRecentPlayers);
     }
   } 
   catch (err) {
     dump("\nSetting preference for recent_players failed: " + err + "\n");
   }

   try {
     gFoxyTunesPref.setCharPref("max_n_recent_charsets", gFoxyTunesMaxRecentCharsets);
   } 
   catch (err) {
     dump("\nSetting preference for max_n_recent_charsets failed: " + err + "\n");
   }

   try {
     gFoxyTunesPref.setCharPref("current_player_options", gFoxyTunesCurrentPlayerOptions);
   } 
   catch (err) {
     dump("\nSetting preference for current_player_options failed: " + err + "\n");
   }

   try {
     gFoxyTunesPref.setCharPref("custom_player_options", gFoxyTunesCustomPlayerOptions);
   } 
   catch (err) {
     dump("\nSetting preference for custom_player_options failed: " + err + "\n");
   }

/* 
   always open in tab

   try {
     gFoxyTunesPref.setBoolPref("open_window_in_tab", gbFoxyTunesOpenWindowInTab);
   } 
   catch (err) {
     dump("\nSetting preference for open_window_in_tab failed: " + err + "\n");
   }
*/

   try {
     gFoxyTunesPref.setCharPref("parent_element_id", gFoxyTunesParentElementID);
   } 
   catch (err) {
     dump("\nSetting preference for parent_element_id failed: " + err + "\n");
   }

   try {
     gFoxyTunesPref.setCharPref("insert_before_element_id", gFoxyTunesInsertBeforeElementId);
   } 
   catch (err) {
     dump("\nSetting preference for insert_before_element_id failed: " + err + "\n");
   }

   try {
     gFoxyTunesPref.setCharPref("insert_after_element_id", gFoxyTunesInsertAfterElementId);
   } 
   catch (err) {
     dump("\nSetting preference for insert_after_element_id failed: " + err + "\n");
   }

   try {
     gFoxyTunesPref.setBoolPref("url_unescape", gbURLUnescape);
   } 
   catch (err) {
     dump("\nSetting preference for url_unescape failed: " + err + "\n");
   }


   try {
	gFoxyTunesPrefService.savePrefFile(null);
   }
   catch (err) {
        dump("\nSaving preferences failed: " + err + "\n");
   }

   gbFoxyTunesIgnorePrefChange = false;
}

function foxytunesReadPreferences() {
   try {
     gFoxyTunesCurrentPlayerClass = gFoxyTunesPref.getCharPref("player_class");
   } 
   catch (err) {
     var bSetDefaultPlayer = false;
     if (foxytunesGetPlatform() == 'windows') {
        // on Windows, default to WMP
        gFoxyTunesCurrentPlayerClass = '@foxytunes.org/FoxyTunes/WindowsMediaPlayer;1'
        bSetDefaultPlayer = true;
     } else if (foxytunesGetPlatform() == 'mac') {
        gFoxyTunesCurrentPlayerClass = '@foxytunes.org/FoxyTunes/iTunes;1'
        bSetDefaultPlayer = true;
     } 

     if (bSetDefaultPlayer) {
        try {
            gFoxyTunesPref.setCharPref("player_class", gFoxyTunesCurrentPlayerClass);
            gFoxyTunesPrefService.savePrefFile(null);
        } catch(e) { dump("Couldn't save player_class pref  - " + e + '\n'); }
     } else {
        gFoxyTunesCurrentPlayerClass = null;
     }
   }

   try {
     gFoxyTunesCharacterEncoding = gFoxyTunesPref.getCharPref("character_encoding");
   } 
   catch (err) {
     gFoxyTunesCharacterEncoding = 'default';
   }

   try {
     gFoxyTunesRecentCharsets = gFoxyTunesPref.getCharPref("recent_charsets");
   } 
   catch (err) {
     gFoxyTunesRecentCharsets = '';
   }

   try {
     gFoxyTunesRecentPlayers = gFoxyTunesPref.getCharPref("recent_players");
   } 
   catch (err) {
     gFoxyTunesRecentPlayers = '';
   }


   try {
     gFoxyTunesMaxRecentCharsets = gFoxyTunesPref.getCharPref("max_n_recent_charsets");
   } 
   catch (err) {
     gFoxyTunesMaxRecentCharsets = 5;
   }

   try {
     gFoxyTunesCustomPlayerOptions = gFoxyTunesPref.getCharPref("custom_player_options");
   } 
   catch (err) {
     gFoxyTunesCustomPlayerOptions = '';
   }

   try {
     gFoxyTunesCurrentPlayerOptions = gFoxyTunesPref.getCharPref("current_player_options");
   } 
   catch (err) {
     gFoxyTunesCurrentPlayerOptions = '';
   }

/*
   always open in tab

   try {
     gbFoxyTunesOpenWindowInTab = gFoxyTunesPref.getBoolPref("open_window_in_tab");
   } 
   catch (err) {
     gbFoxyTunesOpenWindowInTab = true;
   }
*/

   try {
     gFoxyTunesParentElementID = gFoxyTunesPref.getCharPref("parent_element_id");
   } 
   catch (err) {
     gFoxyTunesParentElementID = '';
   }

   try {
     gFoxyTunesInsertBeforeElementId = gFoxyTunesPref.getCharPref("insert_before_element_id");
   } 
   catch (err) {
     gFoxyTunesInsertBeforeElementId = '';
   }

   try {
     gFoxyTunesInsertAfterElementId = gFoxyTunesPref.getCharPref("insert_after_element_id");
   } 
   catch (err) {
     gFoxyTunesInsertAfterElementId = '';
   }


   try {
     gFoxyTunesAutoHideTimeout = gFoxyTunesPref.getIntPref("autohide-timeout");
   } 
   catch (err) {}

   try {
     gbFoxyTunesDontUpdateTitleOnCommand = gFoxyTunesPref.getBoolPref("no_update_title_on_command");
   } 
   catch (err) {
     gbFoxyTunesDontUpdateTitleOnCommand = false;
   }

   try {
     gbFoxyTunesNoTitlePopup = gFoxyTunesPref.getBoolPref("no_title_popup");
   } 
   catch (err) {
     gbFoxyTunesNoTitlePopup = false;
   }

   try {
     gbURLUnescape = gFoxyTunesPref.getBoolPref("url_unescape");
   } 
   catch (err) {
     gbURLUnescape = false;
   }
}

function foxytunesOnSelectPlayer(event) {
    foxytunesSelectPlayer(event.target.getAttribute("value"));
}

function foxytunesUpdateRecentPlayer(newPlayerClass, prevPlayerClass) {
    if (!gFoxyTunesRecentPlayers) {
        // no recent players yet
        gFoxyTunesRecentPlayers = prevPlayerClass;
    } else {
        var playerArr = gFoxyTunesRecentPlayers.split(',');
        var newRecentPlayers = [];
        // remove the player we are switching to and the prev. player from the list
        var nAdded = 0;
        for (var i=0; i < playerArr.length; i++) {
            if ((playerArr[i] != prevPlayerClass) && (playerArr[i] != newPlayerClass)) {
                newRecentPlayers.push(playerArr[i]);
                nAdded++;
                if (nAdded == 2) break;
            }
        }

        // add the prev. player to the head of the list
        newRecentPlayers.unshift(prevPlayerClass);
        gFoxyTunesRecentPlayers = newRecentPlayers.join(",");
    }
}

function foxytunesSelectPlayer(playerClass) {
    if (playerClass == gFoxyTunesCurrentPlayerClass) {
        // nothing to do
        return;
    }

    if (gFoxyTunesCurrentPlayerClass) {
        foxytunesUpdateRecentPlayer(playerClass, gFoxyTunesCurrentPlayerClass);
    }

    gFoxyTunesCurrentPlayerClass = playerClass;
    foxytunesWritePreferences();

    foxytunesDoPlayerSpecificUIChanges();

    gFoxyTunesPlayerObj = null;
    foxytunesInitPlayerObjectIfNeeded();

    var player = foxytunesGetPlayerShortNameFromContractID(gFoxyTunesCurrentPlayerClass);
    var needsConfig = gFTPlayerConfig.needsConfig(player);
    var wasConfigured = gFTPlayerConfig.wasConfigured(player);
    if (needsConfig && !wasConfigured) {
        setTimeout(foxytunesConfigureCurrentPlayer, 10);
    }
}


function foxytunesInitPlayerObjectIfNeeded(bInitUI) {

   if (typeof bInitUI == 'undefined') {
        bInitUI = true;
   }

   if (gFoxyTunesPlayerObj != null) {
	return;
   }
   try {
        //gFoxyTunesPlayerObj = Components.classes[gFoxyTunesCurrentPlayerClass].getService();
        gFoxyTunesPlayerObj = Components.classes['@foxytunes.org/FoxyTunesEngine/FoxyTunesService;1'].getService();
	dump("\nGetting service...\n");
   } 
   catch (err) {
        dump("\nCreateInstance for " + gFoxyTunesCurrentPlayerClass + " failed: " + err + "\n");
	return;
   }

   try {
        //gFoxyTunesPlayerObj = gFoxyTunesPlayerObj.QueryInterface(Components.interfaces.mozIFoxyTunes);
        gFoxyTunesPlayerObj = gFoxyTunesPlayerObj.QueryInterface(Components.interfaces.IFoxyTunesService);
   }
   catch (err) {
        dump("\nQueryInterface for " + gFoxyTunesCurrentPlayerClass + " failed: " + err + "\n");
	gFoxyTunesCurrentPlayerClass = null;
	return;
   }

   if (bInitUI) {
       // mark volume slider as dirty, because we just connected to the player
       foxytunesVolumeSliderPositionDirty("true");
       foxytunesSetPlayerOptions(); // send the options to the player 
   }
}

function foxytunesUpdateTrackTitleAfterCommand() {
	foxytunesUpdateTrackTitleLabel();
	foxytunesUpdateTrackPositionMarker();

        // some players take time to respond:
	if (gFoxyTunesUpdateTitleOnCommandTimerID != 0) {
		clearTimeout(gFoxyTunesUpdateTitleOnCommandTimerID);
	}
        gFoxyTunesUpdateTitleOnCommandTimerID = setTimeout('foxytunesUpdateTrackTitleLabel()', 400);
}

function foxytunesDispatchPlayerCommand(cmd, bUpdateTitle) {
   dump("Dispatching: " + cmd + '\n');
   foxytunesInitPlayerObjectIfNeeded();
   try {
        if (typeof gFoxyTunesPlayerObj[cmd] == 'function') {
            gFoxyTunesPlayerObj[cmd]();
        }
   }
   catch (err) {
        //dump("\n" + cmd + " failed: " + err + "\n");
   }

   // if parameter says we should update 
   // and the preferences didn't override this
   if (bUpdateTitle && !gbFoxyTunesDontUpdateTitleOnCommand) { 
	foxytunesUpdateTrackTitleAfterCommand();
   }
  

   // For WMP - if after 3 secs play doesn't start -> showPlayer
   if ((cmd == 'Play') && 
       (gFoxyTunesCurrentPlayerClass == '@foxytunes.org/FoxyTunes/WindowsMediaPlayer;1')) {
        setTimeout(function () { foxytunesVerifyWMPStartPlaying(); }, 3000);
    }
}

function foxytunesVerifyWMPStartPlaying() {
    if (foxytunesGetCurrentTrackTitle() == '') {
        foxytunesDispatchPlayerCommand('ShowPlayer');
    }
}

function foxytunesSetVolume(volume) {
    foxytunesInitPlayerObjectIfNeeded();
    try {
        gFoxyTunesPlayerObj.SetVolume(volume);
    }
    catch (err) {
        //dump("\n" + 'SetVolume' + " failed: " + err + "\n");
	return false;
    }
    return true;
}

function foxytunesGetVolume() {
    foxytunesInitPlayerObjectIfNeeded();
    var volume = -1;
    try {
        volume = gFoxyTunesPlayerObj.GetVolume();
    }
    catch (err) {
        //dump("\n" + 'GetVolume' + " failed: " + err + "\n");
    }
    return volume;
}

function foxytunesGetCurrentTrackData(bCached) {
    if (!bCached) {
        bCached = false;
    }
    foxytunesInitPlayerObjectIfNeeded();
    var trackData = null;
    try {
        trackData = gFoxyTunesPlayerObj.GetCurrentTrackData(bCached);
		if (trackData.wrappedJSObject) {
			trackData = trackData.wrappedJSObject; 
		} else {
			trackData = trackData.QueryInterface(Components.interfaces.mozIFoxyTunesTrackData);
		}
    } catch (e) {};
    return trackData;
}


function foxytunesGetCurrentTrackTitle(bCached) {
    foxytunesInitPlayerObjectIfNeeded();
    var title = '';
    try {
        //title = gFoxyTunesPlayerObj.GetCurrentTrackTitle();
        title = foxytunesGetCurrentTrackData(bCached).originalTitle;

        if (title == null) {
		    title = '';  // if we are here, there was no exception, so the title
			     // is supported and should be blank
    	}
    }
    catch (err) {}

    // cache the title:
    gFoxyTunesCurrentTrackTitle = title;
    return title;
}

function foxytunesGetCurrentTrackItem(item) {
    foxytunesInitPlayerObjectIfNeeded();
    var itemVal = null;
    try {
        var cmd = 'GetCurrentTrack' + item;
        if (typeof gFoxyTunesPlayerObj[cmd] == 'function') {
            itemVal = gFoxyTunesPlayerObj[cmd]();
        }
    }
    catch (err) {
        //dump("\n" + 'GetCurrentTrackItem (' + item + ") failed: " + err + "\n");
    }
    return itemVal;
}

function foxytunesUpdatePlanetTooltip(event) {
    var target = event.target;
    var title = foxytunesGetCurrentTrackTitle();
    var tooltiptext = foxytunesGetLocaleString('openPlanet');
    if (title && title != '') {
        tooltiptext =  foxytunesGetLocaleString('trackOnThePlanet', ['"' + title + '"']);
    }
    target.setAttribute('tooltiptext', tooltiptext);
}

function foxytunesSetCurrentTrackPosition(pos) {
    foxytunesInitPlayerObjectIfNeeded();
    try {
	gFoxyTunesPlayerObj.SetCurrentTrackPosition(pos);
    } 
    catch (err) {
        //dump("\n" + 'foxytunesSetCurrentTrackPosition failed: ' + err + "\n");
	return false;
    }
    return true;
}

function foxytunesGetTrackInfoTooltipText() {
    var tipText = foxytunesGetCurrentTrackTitle();
    if (tipText == null) {

	var str = foxytunesGetLocaleString("noTrackInfoAvailable");
	return str;
    }

    var pos = foxytunesGetCurrentTrackItem('Position');
    if (pos != null) {
       pos = foxytunesSeconds2TimeStr(pos);
    }
    var length = foxytunesGetCurrentTrackItem('Length');
    if (length != null) {
       length = foxytunesSeconds2TimeStr(length);
    }
    if (length != null) {
	if ((pos != null) && (pos != '0:00')) {
		    // add LRE character to prevent wrong display in Hebrew
		    tipText += " \u202a (" + pos + " / " + length + ") "; 
		    gbFoxyTunesPlaying = true;
    	} else {
		    if (length != '0:00') {
			    tipText += " \u202a (" + length + ") ";
		    }
		    gbFoxyTunesPlaying = false;
    	}
    } else {
	gbFoxyTunesPlaying = false;
    }

    // do not show just zeros or an empty tooltop
    if ((tipText == " \u202a (" + '0:00' + ") ") || (tipText == '')) {
	    var str = foxytunesGetLocaleString("idle");
	    tipText = str;
    }

    return tipText;
}

function foxytunesSetTrackInfoTooltip() {
  var textNode = document.getElementById("foxytunes-track-info-tooltip");
  textNode.setAttribute('value', foxytunesGetTrackInfoTooltipText());
}

function foxytunesHideAllPopupsByType(type) {
  try {
   var elements = document.getElementsByTagName(type);
   for (var i=0; i < elements.length; i++) {
	elements[i].hidePopup();
   } 
  }
  catch (err) {
      dump("\nHideAllPopups error: " + err + "\n");
  }
}

function foxytunesHideAllPopups(type) {
  foxytunesHideAllPopupsByType('menupopup');
  foxytunesHideAllPopupsByType('popup');
}

function foxytunesShowTrackInfoBox(event, bDetach) {
    if (gbFoxyTunesInfoBoxWindowOpened) {
        if (gFoxyTunesInfoBoxWindow && gFoxyTunesInfoBoxWindow.gInfoBox && bDetach) {
            gFoxyTunesInfoBoxWindow.gInfoBox.setDetached(true);
        }
        return; // already open
    }
    gbFoxyTunesInfoBoxWindowOpened = true;

    var win = null;
    win = foxytunesGetMostRecentWindow('foxytunes:infobox');
    if (win) {
        win.focus();
    } else {
        var miniModeWin = null;
        miniModeWin = foxytunesGetMostRecentWindow('foxytunes:minimode');
       

        var needsReposition = false;
        var defaultHeight = 140;
        var infoboxHeight = 0;
        if (typeof gFoxytunesInfoBoxHeight != 'undefined') {
            infoboxHeight = gFoxytunesInfoBoxHeight;
        } else {
            infoboxHeight = defaultHeight;
            needsReposition = true;
        } 

        var bMiniModeInTray = false;
        if (miniModeWin && 
            miniModeWin.gFoxyTunesMiniMode &&
            miniModeWin.gFoxyTunesMiniMode.isMouseInTray()) {
                bMiniModeInTray = true;
        }

        var trackInfoButton = document.getElementById('foxytunes-track-info-statusbar');
        var screenX = bMiniModeInTray ? miniModeWin.gFoxyTunesMiniMode.getTrayX() : trackInfoButton.boxObject.screenX;
        var screenY = bMiniModeInTray ? miniModeWin.gFoxyTunesMiniMode.getTrayY() : trackInfoButton.boxObject.screenY;

        var origScreenY = screenY;

        if (screenY < (window.screen.height/2)) {
            if (!bMiniModeInTray) {
                screenY += trackInfoButton.boxObject.height + 2;
            }
            // we don't need to reposition because window height doesn't matter
            needsReposition = false; 
        } else {
            screenY = screenY - infoboxHeight - 3;
        }
        
        var features = "chrome,dialog=no,all,popup";
        if  (foxytunesGetPlatform() == 'mac') {
            features = "dialog=no, chrome, alwaysRaised, resizable=no";
        }

        features += ",top=" + screenY + "," + "left=" + screenX;
        win = window.openDialog("chrome://foxytunes/content/infobox/infobox.xul", 
                            "_blank", 
                            features,
                            foxytunesGetCurrentTrackData(),
                            bDetach);
        if (needsReposition) {
            var adjustInfoBoxPos = function() {
                    if (typeof gFoxytunesInfoBoxHeight == 'undefined') {    
                        setTimeout(adjustInfoBoxPos, 10);
                    } else {
                        var oldScreenY = screenY;
                        screenY = origScreenY - gFoxytunesInfoBoxHeight - 3;
                        win.moveBy(0, screenY - oldScreenY);
                        setTimeout(foxytunesCancelHideTrackInfoBox, 100);
                    }
            }
            setTimeout(adjustInfoBoxPos, 10);
        }
    }

    gFoxyTunesInfoBoxWindow = win;
}

function foxytunesCancelHideTrackInfoBox() {
    if (gFoxyTunesInfoBoxHideTimerId) {
        clearTimeout(gFoxyTunesInfoBoxHideTimerId);
        gFoxyTunesInfoBoxHideTimerId = null;
    }
}

function foxytunesTriggerHideTrackInfoBox(event) {
    // if we are going to show - don't do it
    foxytunesCancelShowTrackInfoPopup();

    foxytunesCancelHideTrackInfoBox();
    // if we are showing - schedule a hide
    gFoxyTunesInfoBoxHideTimerId = setTimeout(foxytunesHideTrackInfoBox, 700);
}

function foxytunesHideTrackInfoBox(event) {
    if (gFoxyTunesInfoBoxWindow) {
        if (gFoxyTunesInfoBoxWindow.gInfoBox && 
            gFoxyTunesInfoBoxWindow.gInfoBox.isDetached()) {
            // do not hide when detached
            return;
        }
        gFoxyTunesInfoBoxWindow.close();
        gFoxyTunesInfoBoxWindow = null;
        gbFoxyTunesInfoBoxWindowOpened = false;
    }
}

function foxytunesCancelShowTrackInfoPopup() {
    if (gFoxyTunesInfoBoxShowTimerId) {
        clearTimeout(gFoxyTunesInfoBoxShowTimerId);
    }
    gFoxyTunesInfoBoxShowTimerId = 0;
}

function foxytunesTriggerShowTrackInfoPopup(event) {
    if (!event.relatedTarget) {
        // we somehow got to this button from the outside
        // ignore
        return;
    }
    foxytunesCancelShowTrackInfoPopup();

    var timeout;
    if (typeof(event.bInfoBoxFromTray) == 'undefined') {
        timeout = gFoxytunesPreferenceManager.getPref('infobox.show.popup.timeout', 500);
    } else {
        timeout = gFoxytunesPreferenceManager.getPref('tray.infobox.show.popup.timeout', 800);
    }
    gFoxyTunesInfoBoxShowTimerId = setTimeout(foxytunesShowTrackInfoPopup, timeout);
}

function foxytunesShowTrackInfoPopup(event, bDetach) {
    
    foxytunesCancelShowTrackInfoPopup();
    foxytunesCancelHideTrackInfoBox();
    if (typeof bDetach == 'undefined') {
        bDetach = false;
    }

    foxytunesShowTrackInfoBox(event, bDetach);

    return true; // new infobox
    
   // do not enter twice!!
   if (gbFoxyTunesInfoPopupVisible) return true;

   var popup = document.getElementById('foxytunes-track-info-popup');
   var trackInfoButton = document.getElementById('foxytunes-track-info-statusbar');

   // Firefox crash on Mac, during hide popup https://bugzilla.mozilla.org/show_bug.cgi?id=264657
   if (gbFoxyTunesNoTitlePopup) { 
	var title = foxytunesGetCurrentTrackTitle();
	if (title == '') {
		var str = foxytunesGetLocaleString("idle");
		title = str;
	}

	trackInfoButton.setAttribute('tooltiptext', title);
	return true;
   }

   // I must hide all the popups, because if there is a visible popup
   // it will hang on the screen after I call my showPopup (Bug?)
   foxytunesHideAllPopups();

   document.popupNode = trackInfoButton;

   // should be like to following line, causes strange jumps:
   //popup.showPopup(trackInfoButton, -1, -1, "popup", "topleft", "bottomleft");

   var offset;
   if (gFoxyTunesTrackInfoTooltipHeight != 0) {
	offset = gFoxyTunesTrackInfoTooltipHeight; 
   } else {
	offset = trackInfoButton.boxObject.height*2;
   }

   if (trackInfoButton.boxObject.screenY < (window.screen.height/2)) {
       offset = -offset; 
   }

   popup.showPopup(trackInfoButton, 
		trackInfoButton.boxObject.x, 
		trackInfoButton.boxObject.y - offset, 
		"tooltip", "topleft", "bottomleft");

   if (gFoxyTunesTrackInfoTooltipHeight == 0) {
    // this is the first time we show the popup
	// remember the height for the next time
	// reshow at the correct place
	gFoxyTunesTrackInfoTooltipHeight = popup.boxObject.height + 4;
    //if  (foxytunesGetPlatform() != 'mac') {
        // on mac this hangs the world
    	popup.showPopup(trackInfoButton, 
	    	trackInfoButton.boxObject.x, 
    		trackInfoButton.boxObject.y - gFoxyTunesTrackInfoTooltipHeight, 
	    	"tooltip", "topleft", "bottomleft");
//    }
   } 

//   dump("\nShowing TrackInfoPopup\n"); 
   return true;
}

function foxytunesHideTrackInfoPopup(event) {
   foxytunesHideTrackInfoBox();
   return true; // new infobox     

   // Firefox crash on Mac, during hide popup https://bugzilla.mozilla.org/show_bug.cgi?id=264657
   if (gbFoxyTunesNoTitlePopup) {
	return true;
   } 
   document.getElementById('foxytunes-track-info-popup').hidePopup(); 
   return true;
}

function foxytunesStartTrackInfoTooltip() {
  gbFoxyTunesInfoPopupVisible = true;
  foxytunesSetTrackInfoTooltip();

  // update the track title display:
  foxytunesSetCurrentTrackTitleLabel(gFoxyTunesCurrentTrackTitle);

  if (gFoxyTunesTrackInfoTimerID != 0) {
	// clear the previous timeout if exists
	// so we don't have multiple timers
	clearTimeout(gFoxyTunesTrackInfoTimerID);
	gFoxyTunesTrackInfoTimerID = 0;
  }

  if (gbFoxyTunesPlaying) {
	  gFoxyTunesTrackInfoTimerID = setTimeout('foxytunesStartTrackInfoTooltip()', 1000);
  } else {
	  gFoxyTunesTrackInfoTimerID = 0;
  }
  return true;
}

function foxytunesEndTrackInfoTooltip() {
  gbFoxyTunesInfoPopupVisible = false;
  if (gFoxyTunesTrackInfoTimerID != 0) {
	clearTimeout(gFoxyTunesTrackInfoTimerID);
        dump("\nTrackInfoTimer " + gFoxyTunesTrackInfoTimerID + " ended\n");
	gFoxyTunesTrackInfoTimerID = 0;
  } 
  return true;
}

function foxytunesVolumeSliderChanged(event) {
   if ((event.attrName == 'curpos') && !gbFoxyTunesChangingSliderPos) {
	//dump("\nChanging volume to " + event.newValue  + "\n");
	var changed = foxytunesSetVolume(event.newValue);
	if (! changed) {
		// couldn't set volume try increase/decrease
		if (event.newValue > event.prevValue) {
			foxytunesDispatchPlayerCommand('IncreaseVolume');
		} else if (event.newValue < event.prevValue) {
			foxytunesDispatchPlayerCommand('DecreaseVolume');
		}
		// the foxytunesSetVolume method failed, return slider to the middle
		setTimeout('foxytunesSetVolumeSliderPosition(50)', 1000);
	}
   }
   return false;
}

// this function sets the volume slider curpos, 
// but temporarily disables DOMAttrModified event processing 
// it is used when the GUI position of the slider has to be changed, 
// but no SetVolume calls need to be made
function foxytunesSetVolumeSliderPosition(pos) {
  gbFoxyTunesChangingSliderPos = true;  // foxytunesVolumeSliderChanged will ignore the event

  var volumeSlider = document.getElementById('foxytunes-volume-slider'); 
  volumeSlider.setAttribute('curpos', pos);

  gbFoxyTunesChangingSliderPos = false;
}

// set to true if the slider position doesn't reflect the actual volume
// and needs to be update when needed, false if it does
// call without params to get the current dirty value
function foxytunesVolumeSliderPositionDirty(dirty) {
   var volumeSliderWidget = document.getElementById('foxytunes-volume-slider-widget'); 
   if (dirty == null) {
       	return volumeSliderWidget.getAttribute('dirty');
   } else {
  	volumeSliderWidget.setAttribute('dirty', dirty);
	return null;
   }
}

// update the volume slider position with the current volume
function foxytunesRefreshVolumeSliderPosition() {
   // if the slider is visible, update its position
   var volumeSliderWidget = document.getElementById('foxytunes-volume-slider-widget');
   if (volumeSliderWidget.getAttribute('hidden') == 'false') {
	var volume = foxytunesGetVolume();
    //dump('volume ' + volume + "\n");
	if (volume == -1) {		
		// cannot get volume, set the slider to the middle
		volume = 50;
	}
	foxytunesSetVolumeSliderPosition(volume);
        foxytunesVolumeSliderPositionDirty("false");
   }
}

function foxytunesRefreshVolumeSliderIfDirty() {
   if (foxytunesVolumeSliderPositionDirty() == 'true') {
	foxytunesRefreshVolumeSliderPosition();
   } 
}

function foxytunesIncreaseVolume() {
    foxytunesDispatchPlayerCommand('IncreaseVolume');
    foxytunesRefreshVolumeSliderPosition();
}

function foxytunesDecreaseVolume() {
    foxytunesDispatchPlayerCommand('DecreaseVolume');
    foxytunesRefreshVolumeSliderPosition();
}

function foxytunesScrollOnVolumeControls(event) {
   event.preventDefault();
   if (event.detail > 0) {
	foxytunesDecreaseVolume();
   } else {
	foxytunesIncreaseVolume();
   }
}

function foxytunesToggleObjectVisibilityWithArrow(arrow, object, bInverted) {
  var hidden = object.getAttribute('hidden');
  var side;
  if (hidden == 'true') {
	hidden = 'false';
	side = 'left';
  } else {
	hidden = 'true';
	side = 'right';
  }
  if (bInverted) {
	if (side == 'left') {
		side = 'right';
	} else {
		side = 'left';
	}
  }
  arrow.setAttribute('class', side + " foxytunes-statusbar-arrow-button");
  object.setAttribute('hidden', hidden);

  if (foxytunesIsInMinimode()) {
        gFoxyTunesMiniMode.adjustSize();
  }
}

function foxytunesToggleURLUnescapeTitle(event)
{
  gbURLUnescape = !gbURLUnescape;
  foxytunesWritePreferences();
}

function foxytunesToggleOpenWindowInTab(event)
{
  gbFoxyTunesOpenWindowInTab = !gbFoxyTunesOpenWindowInTab;
  foxytunesWritePreferences();
}

function foxytunesToggleSeparatorsVisibility(event) {
  var menuItem = event.target;
  var bHidden = event.target.getAttribute('checked');
  var foxyTunes = document.getElementById('foxytunes-statusbar-panel');
  var separators = foxyTunes.getElementsByTagName('toolbarseparator');
  for (var i = 0; i < separators.length; i++) {
	separators[i].setAttribute('hidden', bHidden);
  }

  if (foxytunesIsInMinimode()) {
        gFoxyTunesMiniMode.adjustSize();
  }
}

function foxytunesToggleButtonVisibility(event) {
  var menuItem = event.target;
  var targetButtonID = menuItem.getAttribute('foxytunes-item');
  var targetButton = document.getElementById(targetButtonID);
  targetButton.setAttribute("hidden", menuItem.getAttribute("checked"));

  if (foxytunesIsInMinimode()) {
        gFoxyTunesMiniMode.adjustSize();
  }
}

function foxytunesToggleVolumeSliderVisibility(event) {
  var arrowButton = event.target; 
  var volumeSlider = document.getElementById('foxytunes-volume-slider-widget'); 
  foxytunesToggleObjectVisibilityWithArrow(arrowButton, volumeSlider);
  foxytunesRefreshVolumeSliderPosition();

  if (foxytunesIsInMinimode()) {
        gFoxyTunesMiniMode.adjustSize();
  }
}

function foxytunesAllButtonsAutoHideIsOn() {
  var autoHideMenuItem = document.getElementById('foxytunes-main-panel-auto-hide-toggle');
  return (autoHideMenuItem.getAttribute('checked') == 'true');
}

function foxytunesAllButtonsMouseOver() {
  // cancel all timers
  if (gFoxyTunesAllButtonsAutohideTimerID != 0) {
	clearTimeout(gFoxyTunesAllButtonsAutohideTimerID);
  }
}

function foxytunesAllButtonsMouseOut() {
  if (! foxytunesAllButtonsAutoHideIsOn()) {
  	// auto-hide is off, nothing to do
	return;
  }

  var arrowButton = document.getElementById('foxytunes-toggle-all-buttons-container-visibility-statusbar'); 
  var allButtons = document.getElementById('foxytunes-all-buttons-container-statusbar'); 
  var bHidden = (allButtons.getAttribute('hidden') == 'true');

  if (bHidden) {
	// already hidden, nothing to do
	return;
  }

  // stop the previous timers if exist
  if (gFoxyTunesAllButtonsAutohideTimerID != 0) {
	clearTimeout(gFoxyTunesAllButtonsAutohideTimerID);
  }

  // schedule auto-hide
  gFoxyTunesAllButtonsAutohideTimerID = 
			setTimeout(foxytunesToggleObjectVisibilityWithArrow, gFoxyTunesAutoHideTimeout, arrowButton, allButtons, false);
}

function foxytunesToggleAllButtonsVisibility(event, bHovering) {
  var arrowButton = event.target; 
  var allButtons = document.getElementById('foxytunes-all-buttons-container-statusbar'); 
  var bHidden = (allButtons.getAttribute('hidden') == 'true');

  // if hovering and the panel is already visible, or auto-hide is off, return
  if (bHovering && (!bHidden || !foxytunesAllButtonsAutoHideIsOn())) {	
	return;
  }

  foxytunesToggleObjectVisibilityWithArrow(arrowButton, allButtons);
}

function foxytunesOpenFoxyTunesAboutDialog() {
  window.open('chrome://foxytunes/content/about.xul','','chrome,centerscreen');
}

function foxytunesGetAllKeys() {
	var foxytunesKeys = new Array();
	var mainKeySet = document.getElementById('mainKeysetFoxyTunes');
	var keyElements = mainKeySet.getElementsByTagName('key');
	for (var i = 0; i < keyElements.length; i++) {
		var keyElement = keyElements[i];
		var id = keyElement.id;
		try {
			var idArray = id.split("-");
			if (idArray[0].toLowerCase() != 'foxytunes') {
				continue;
			}
		} catch(e) {
			continue;
		}
 
		//dump("Found FoxyTunes key: " + id + "\n");
		foxytunesKeys.push(keyElement);
	}
	return foxytunesKeys;
}

function foxytunesOverrideKeyIfNeeded(keyElem) {

	if (foxytunesGetPlatform() != 'mac') {
		// currently, overrides are only for mac
		return;
	}

	if (keyElem.hasAttribute('origmackey')) {
		var keyOrigMac = keyElem.getAttribute('origmackey');
		keyElem.setAttribute('origkey', keyOrigMac);
	}

	if (keyElem.hasAttribute('origmackeycode')) {
		var keyCodeOrigMac = keyElem.getAttribute('origmackeycode');
		keyElem.setAttribute('origkeycode', keyCodeOrigMac);
	}

	if (keyElem.hasAttribute('origmacmodifiers')) {
		var modifiersOrigMac = keyElem.getAttribute('origmacmodifiers');
		keyElem.setAttribute('origmodifiers', modifiersOrigMac);
	}
}

function foxytunesInitKeyboardShortcuts() {
	var keys = foxytunesGetAllKeys();

	var bUseShortcuts = foxytunesReadSinglePreference('use_shortcuts', 
								foxytunesShortcutsEnabledByDefault());

	for (var i = 0; i < keys.length; i++) {
		var keyElem = keys[i];

		if ((keyElem.getAttribute('keyenabled') == 'false') || (bUseShortcuts != 'true')) {
			if (keyElem.hasAttribute('command')) {
				keyElem.setAttribute('origcommand', keyElem.getAttribute('command'));
				keyElem.removeAttribute('command');
			}

			if (keyElem.hasAttribute('oncommand')) {
				keyElem.setAttribute('origoncommand', keyElem.getAttribute('oncommand'));
				keyElem.removeAttribute('oncommand');
			}
		}

		// change the defaults if needed for different platforms
		foxytunesOverrideKeyIfNeeded(keyElem);

		var key = keyElem.getAttribute('key');
		var keyCode = keyElem.getAttribute('keycode');
		var modifiers = keyElem.getAttribute('modifiers');

		if (!key && !keyCode) {
			// we have to initialize this shortcut
			var keyOrig = keyElem.getAttribute('origkey');
			var keyCodeOrig = keyElem.getAttribute('origkeycode');
			var modifiersOrig = keyElem.getAttribute('origmodifiers');

			keyElem.setAttribute('modifiers', modifiersOrig);

			if (keyOrig) {
				keyElem.setAttribute('key', keyOrig);
			} else {
				keyElem.setAttribute('keycode', keyCodeOrig);
			}
		} 
	}
}

function foxytunesOpenConfigureShortcutsDialog(bReadOnly) {
  window.openDialog('chrome://foxytunes/content/foxytunesShortcuts.xul',
							'',
							'chrome,centerscreen,modal',
							foxytunesGetAllKeys(), bReadOnly);
}

function foxytunesSubscribeToNewsletter(url, title) {
  var email = prompt(title, '');
  if ((email != null) && (email != '')) {
	url += '?operation=subscribe&user_email=' + escape(email);
  	foxytunesGoToURL(url);
  }
}

function foxytunesDoPlayerSpecificUIChanges() {
    if (!gFoxyTunesCurrentPlayerClass) return;

    var playBackControlsElem = document.getElementById('foxytunes-playback-controls-statusbar');
    if (gFoxyTunesCurrentPlayerClass.match(/pandora/i)) {
            playBackControlsElem.setAttribute('disabled', 'true');
    } else {
            playBackControlsElem.removeAttribute('disabled');
    }
}

function foxytunesSetPlayerOptions() {
   if (gFoxyTunesPlayerObj != null) {
	try {
   		var home = foxytunesGetHome();
		var bCharaterEncodingOn = (gFoxyTunesCharacterEncoding != 'default');
		var options = ''; 
		options += " -home " + home.path;
		if (bCharaterEncodingOn) {
			options += " -encoded_chars ";
		}

        var player = foxytunesGetPlayerShortNameFromContractID(gFoxyTunesCurrentPlayerClass);
        var configCommandLine = gFTPlayerConfig.getPlayerConfigCommandLine(player);
        if (configCommandLine) {
            options += ' ' + configCommandLine;
        }

        options += ' ' + gFoxyTunesCurrentPlayerOptions;
		gFoxyTunesPlayerObj.SetOptions(options);

        foxytunesDoPlayerSpecificUIChanges();
	}
	catch (err) {
		dump("\nCouldn't set player options: " + err + "\n");
	}
   }
}

function foxytunesSetPlayerOptionsPreset(event) {
    var item = event.target;
    gFoxyTunesCurrentPlayerOptions = item.value;
    foxytunesWritePreferences();
    foxytunesSetPlayerOptions(); // send the options to the player (null protected)
}

function foxytunesSetPlayerOptionsCustom(event, title) {
    var options = prompt(title, gFoxyTunesCustomPlayerOptions);
    if (options != null) {
	  gFoxyTunesCustomPlayerOptions = options;
	  gFoxyTunesCurrentPlayerOptions = options;
	  foxytunesWritePreferences();
	  foxytunesSetPlayerOptions(); // send the options to the player (null protected)
    }
}

function foxytunesRegisterGlobalScrollEvent(event) {
    if (event.type == "mouseover") {
//	dump('Added global scroll listener\n');
	window.addEventListener("DOMMouseScroll", foxytunesScrollOnVolumeControls, false);
    } else {
//	dump('Removed global scroll listener\n');
	window.removeEventListener("DOMMouseScroll", foxytunesScrollOnVolumeControls, false);
    }
}

function foxytunesRegisterVolumeSliderEvents() {
   var volumeSlider = document.getElementById('foxytunes-volume-slider'); 
   volumeSlider.addEventListener("DOMAttrModified", foxytunesVolumeSliderChanged, false);
   var platform = foxytunesGetPlatform();

   var targetIDs = ['foxytunes-all-buttons-container-statusbar', 'foxytunes-main-menu-statusbar'];
   for (var i = 0; i < targetIDs.length; i++) {
	  var targetElem = document.getElementById(targetIDs[i]);
	  if (platform != 'linux') {
		  targetElem.addEventListener("DOMMouseScroll", foxytunesScrollOnVolumeControls, false);
	  } else {
  		 // on Linux the above doesn't seem to work, the scroll needs to be a global window event
		 targetElem.addEventListener("mouseover", foxytunesRegisterGlobalScrollEvent, false);
		 targetElem.addEventListener("mouseout", foxytunesRegisterGlobalScrollEvent, false);
	  }
   }
}

function foxytunesInitVolumeSlider() {
   foxytunesRegisterVolumeSliderEvents();

   // see if we should actualy query the player for the actual volume on startup and update
   // the slider position, or defer this operation until the first mouse over (default)
   var confItem = document.getElementById('foxytunes-configuration-update-volume-on-startup');
   if (confItem.getAttribute('checked') == 'true') {
           foxytunesRefreshVolumeSliderPosition();
   } else {
	   foxytunesVolumeSliderPositionDirty("true");
   }
}

function foxytunesInsertPlayersMenuItem(label) {
   var popup = document.getElementById('foxytunes-available-player-popup');

   var str = foxytunesGetLocaleString(label);

   // replace 'Firefox' with the correct host if needed
   str = foxytunesAdjustStringForCorrectHost(str);

   var newElement;
   newElement = document.createElement('menuitem');
  // newElement.setAttribute('type', 'radio');
   newElement.setAttribute('name', 'foxytunes-player');
   newElement.setAttribute('label', str);
   newElement.setAttribute('tooltiptext', str);
   newElement.setAttribute('checked', 'true');
   newElement.setAttribute('command', 'cmd_foxytunes-failed-xpcom-install');
   var sep = document.createElement('menuseparator');
   popup.insertBefore(sep, popup.firstChild);
   popup.insertBefore(newElement, popup.firstChild);

   //popup.appendChild(newElement);
}


function foxytunesGetProfileDir() {
   var dirServiceProp = Components.classes["@mozilla.org/file/directory_service;1"];
   dirServiceProp = dirServiceProp.getService(Components.interfaces.nsIProperties);
   var profileDir = dirServiceProp.get("ProfD", Components.interfaces.nsIFile);
   return profileDir;
}

function foxytunesGetHome() {
   const id = "{463F6CA5-EE3C-4be1-B7E6-7FEE11953374}";
var foxyTunesHome = Components.classes["@mozilla.org/extensions/manager;1"]
                    .getService(Components.interfaces.nsIExtensionManager)
                    .getInstallLocation(id)
                    .getItemLocation(id); 

/*
   var profileDir = foxytunesGetProfileDir();
   var foxyTunesHome = profileDir.clone();
   foxyTunesHome.append('extensions');
   foxyTunesHome.append('{463F6CA5-EE3C-4be1-B7E6-7FEE11953374}');
*/

   return foxyTunesHome;
}

function foxytunesGetComponentFile(filename) {
   var home = foxytunesGetHome();
   var componentFile = home.clone();
   componentFile.append('components');
   componentFile.append(filename);
   return componentFile;
}

function foxytunesRemoveRegistryFiles() {
   var profileDir = foxytunesGetProfileDir();
   var compregFile = profileDir.clone();
   compregFile.append('compreg.dat');
   compregFile.remove(false);
   dump("\nRemoved " + compregFile.path + "\n");

   var xptiFile = profileDir.clone();
   xptiFile.append('xpti.dat');
   xptiFile.remove(false);
   dump("\nRemoved " + xptiFile.path + "\n");
}


function foxytunesInstallPlatformSpecificLibraryIfNeeded() {
   return false;

   if (foxytunesIsInMozilla()) {
	// we are in Mozilla, installed properly through install.js
	return false;
   }

   var platform = foxytunesGetPlatform();
   var platformFull = foxytunesGetPlatformFull();
   
   if (platform == 'windows') {
		// the default dll is for windows
		return false;
   }

   var platformSpecificFileName = 'FoxyTunes.dll.' + platform;

   var foxyTunesDllPlatformSpecificFile = 
			foxytunesGetComponentFile(platformSpecificFileName);

   if (!foxyTunesDllPlatformSpecificFile.exists()) {
	// the file doesn't exist, we already renamed it
 	return false;
   }

   // the file exists, rename it, so it becomes the main library file
   dump("\nRenaming " + platformSpecificFileName + " to FoxyTunes.dll\n");
   foxyTunesDllPlatformSpecificFile.moveTo(null, 'FoxyTunes.dll');

   // re-get the file (because it now points to the new name):
   foxyTunesDllPlatformSpecificFile = 
		foxytunesGetComponentFile(platformSpecificFileName);

   if (foxyTunesDllPlatformSpecificFile.exists()) {
	// the file still exists, something's wrong
	dump("\nFailed renaming " + platformSpecificFileName + " to FoxyTunes.dll\n");
	return false; 
   }

   // load the dll so the user doesn't have to restart the browser to see the change
   var mainDLLFile = foxytunesGetComponentFile('FoxyTunes.dll');
   var componentRegistrar = Components.manager.QueryInterface(Components.interfaces.nsIComponentRegistrar);
   try {
       componentRegistrar.autoRegister(mainDLLFile);
   } catch(err) {
     	dump("\nFailed autoRegistering renamed platform specific FoxyTunes.dll\n");
	return false; 
   }

   // the file existed, we have renamed (installed) it
   // remove compreg.dat and xpti.dat files, so on the next install
   // the file will get registered 
   // remark: with auto-registration above, this probably is no longer needed
   foxytunesRemoveRegistryFiles();

   return true;
}

function foxytunesGetFoxyTunesEMItem(item) {
  var value = null;
  try {
   var RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"]
             .getService(Components.interfaces.nsIRDFService);
   var extensionDS= Components.classes["@mozilla.org/extensions/manager;1"]
	      .getService(Components.interfaces.nsIExtensionManager).datasource;
   var root = RDFService
             .GetResource("urn:mozilla:item:{463F6CA5-EE3C-4be1-B7E6-7FEE11953374}");
   var itemArc = RDFService
             .GetResource("http://www.mozilla.org/2004/em-rdf#" + item);

   
   var target = extensionDS.GetTarget(root, itemArc, true);
   value = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
  } catch(e) {}
  return value;
}

function foxytunesGetFoxyTunesVersion() {
  return foxytunesGetFoxyTunesEMItem('version');
}

function foxytunesGetFoxyTunesAvailableUpdateVersion() {
  return foxytunesGetFoxyTunesEMItem('availableUpdateVersion');
}

function foxytunesFoxyTunesHasUpdates() {
    var availableUpdateURL = foxytunesGetFoxyTunesEMItem('availableUpdateURL');
    return availableUpdateURL && (availableUpdateURL != 'none');
}

function foxytunesGotoUpdateURL() {
    var ftVersion = foxytunesGetFoxyTunesVersion();
    var url = 'http://www.foxytunes.com/firefox/update/';
    if (ftVersion) {
        url += '?version=' + ftVersion;
    }
    foxytunesGoToURL(url);
}

function foxytunesDisableUpdateAvailableButton() {
    var ftVersion = foxytunesGetFoxyTunesAvailableUpdateVersion();
    if (!ftVersion) return;

    var prefName = 'update_button_disabled_' + ftVersion;
    gFoxyTunesPref.setBoolPref(prefName, true);

    // this will actually hide the button now
    foxytunesShowUpdateAvailableButtonIfNeeded();

    if (foxytunesIsInMinimode()) {
        gFoxyTunesMiniMode.adjustSize();
    }
}

function foxytunesUpdateAvailableButtonIsDisabled() {
    var ftVersion = foxytunesGetFoxyTunesAvailableUpdateVersion();
    if (!ftVersion) return true; // if something unexpected happened, don't show the button

    var prefName = 'update_button_disabled_' + ftVersion;

    var bDisabled = false;
    try {
        bDisabled = gFoxyTunesPref.getBoolPref(prefName);
    } catch(e) {}
    return bDisabled;
}

function foxytunesShowUpdateAvailableButtonIfNeeded() {
    var panel = document.getElementById('foxytunes-update-available-panel');
    var menuitem = document.getElementById('foxytunes-update-available-menuitem');

    var bHasUpdates    = foxytunesFoxyTunesHasUpdates();
    var bIsDisabled    = foxytunesUpdateAvailableButtonIsDisabled();
    var bIsInThunderbird = foxytunesIsInThunderbird();

    var bShowPanelIcon = bHasUpdates && !bIsDisabled && !bIsInThunderbird;
    panel.hidden = !bShowPanelIcon;

    var bShowMenuItem = bHasUpdates && !bIsInThunderbird;
    menuitem.hidden = !bShowMenuItem;
}


function foxytunesRenameMainDll() {
   var foxyTunesDll = foxytunesGetComponentFile('FoxyTunes.dll');
   if (!foxyTunesDll.exists()) {
	// the file doesn't exist, something unexpected happend 
 	return false;
   }

   // the file exists, rename it, so it the install can succeed next
   // time firefox is started
   dump("\nRenaming FoxyTunes.dll to FoxyTunes.dll.uninstalled\n");
   foxyTunesDll.moveTo(null, 'FoxyTunes.dll.uninstalled');
   // re-get the file (because it now points to the new name):
   foxyTunesDll = foxytunesGetComponentFile('FoxyTunes.dll');
   if (foxyTunesDll.exists()) {
	// the file still exists, something's wrong 
	dump("\nFailed renaming FoxyTunes.dll to FoxyTunes.dll.uninstalled\n");
	return false; 
   }

   return true;
}

function foxytunesThunderbirdSpecificInit() {
   if (!foxytunesIsInThunderbird()) {
	// this is not Thunderbird
	return;
   }

   // do something Thunderbird specific here:
   foxytunesDisableFoxyTunesMini();

   try {
       gFoxytunesThunderbirdSignatures = new FoxytunesThunderbirdSignatures();
       gFoxytunesThunderbirdSignatures.init();
   } catch(e) {};
}

function foxytunesSeaMonkeySpecificInit() {
   if (!foxytunesIsInMozilla()) {
	// this is not SeaMonkey
	return;
   }

   foxytunesDisableFoxyTunesMini();

   // Disablling TwittyTunes extra - no extension-manager
   try {
        document.getElementById('foxytunes-twittytunes-menu-item').hidden = true;
   } catch(e) { dump('error disabling TwittyTunes menuitem  ' + e + '\n'); }

   try {
        document.getElementById('foxytunes-extras-separator-1').hidden = true;
   } catch(e) { dump('error disabling TwittyTunes extras separator  ' + e + '\n'); } 
}

function foxytunesEmusicSpecificInit() {
    if (!foxytunesIsInEmusic()) {
        return;
    }
    var infoCenterButton = document.getElementById('foxytunes-info-center-statusbar');
    if (infoCenterButton) {
        infoCenterButton.hidden = true;
    }
}

function foxytunesShowRestartBrowserAlert() {
   var str = foxytunesGetLocaleString('pleaseRestartFirefoxAlert');
   // replace 'Firefox' with the correct host if needed
   str = foxytunesAdjustStringForCorrectHost(str);
   alert(str);
}

function foxytunesRestoreIfHidden(event, prompt) {

	if (!confirm(prompt)) {
		return; 
	}

	var foxyTunes = document.getElementById('foxytunes-statusbar-panel');
	foxyTunes.setAttribute('hidden', 'false');	

	// hide the "restore" button
	event.target.setAttribute('hidden', 'true');
}

function foxytunesVerifyWidth() {
	var foxyTunes = document.getElementById('foxytunes-statusbar-panel');
	var statusBar = document.getElementById('status-bar');
	var doc = document.documentElement;

	var foxyTunesWidth = foxyTunes.boxObject.width;
	var statusBarWidth = statusBar.boxObject.width;
	var windowWidth = doc.boxObject.width; 

	var restoreFoxyTunesButton = document.getElementById('foxytunes-statusbar-restore-foxytunes');

	if (windowWidth < 2) {
		// seems that this function was called too soon (no width yet)
		return;
	}

//	dump('Status bar width:' + statusBarWidth + ", window width: " + windowWidth + "\n");

	var bOverflowHidden = (foxyTunes.getAttribute('foxy-overflow-hidden') == 'true');

	// the status bar should never be wider than the documents (window)
	// hide FoxyTunes
	// if bOverflowHidden is true, don't hide (this means that visibility was forced)
	if ((statusBarWidth > windowWidth) && !bOverflowHidden) {
		dump('Status bar is too wide (' + statusBarWidth + " > " + windowWidth + "). Hiding FoxyTunes...\n");

		foxyTunes.setAttribute('hidden', 'true');
		foxyTunes.setAttribute('foxy-overflow-hidden', 'true');
		restoreFoxyTunesButton.setAttribute('hidden', 'false');

		gFTLastWindowWidth = windowWidth;
		gFTLastFoxyTunesWidth = foxyTunesWidth;
	} else {
		if  (bOverflowHidden) {
			// did the window grow wider since we last hidden FoxyTunes?
			var bDocGotWider = (windowWidth > gFTLastWindowWidth);

			// would FoxyTunes fit in the window if we showed it?
			// add some width to foxytunes to make sure it fits
			var bEnoughSpace = (windowWidth > (gFTLastFoxyTunesWidth + 250));

			if (bDocGotWider && bEnoughSpace) {
				foxyTunes.setAttribute('hidden', 'false');	
				foxyTunes.setAttribute('foxy-overflow-hidden', 'false');
				restoreFoxyTunesButton.setAttribute('hidden', 'true');
				dump("The browser is now wide enough. Restoring FoxyTunes...\n");
			}
		}
	}
}

function foxytunesOnBrowserStatusChanged(event) {
	if (event.attrName != 'label') {
		// only label changes interest us
		return;
	}

	var foxytunesWidget = document.getElementById('foxytunes-statusbar-panel');
	var bFoxyTunesIsOnStatusBar = foxytunesWidget.parentNode.tagName == 'statusbar';

	if (!bFoxyTunesIsOnStatusBar) {
		// FT is not on the status bar - hiding it won't help
		return;
	}

	var bHiddenToRevealStatus = foxytunesWidget.getAttribute('foxy-see-status-hidden') == 'true';

	// proceed only if:
	// 1. shift is pressed - consider hiding FT or
	// 2. FT is hidden - consider revealing it
	if (!gbFoxyTunesShiftDown && !bHiddenToRevealStatus) {
		 return;
	}

	var statusElem = event.target;
	var width = statusElem.boxObject.width;

	// temporarily remove flex to measure the real width (shouldn't cause a re-flow...)
	var oldFlex = statusElem.getAttribute('flex'); 
	statusElem.setAttribute('flex', '0');
	var fullWidth = statusElem.boxObject.width;
	statusElem.setAttribute('flex', oldFlex);

	//dump('Status width - current: ' + width + ", full: " + fullWidth + '\n');

	if ((fullWidth > width) && gbFoxyTunesShiftDown) {
		// the full width is bigger than the current width, hide if not already hidden
		if (!bHiddenToRevealStatus) {
			foxytunesWidget.setAttribute('hidden', 'true');
			foxytunesWidget.setAttribute('foxy-see-status-hidden', 'true');
		}
	} else {
		// the full width is smaller than the current width, reveal if hidden
		// don't reveal if the shift is still down
		if (bHiddenToRevealStatus && !gbFoxyTunesShiftDown) {
			foxytunesWidget.setAttribute('hidden', 'false');
			foxytunesWidget.setAttribute('foxy-see-status-hidden', 'false');
		}
	}
}

function foxytunesOnMouseMove(event) {
	var bOldShiftDown = gbFoxyTunesShiftDown;
	gbFoxyTunesShiftDown = event.shiftKey;

	// shift state changed, trigger DOMAttrModified on the main status display
	if (gbFoxyTunesShiftDown != bOldShiftDown) {
		// trigger DOMAttrModified on the main status display
		var statusbarDisplay = document.getElementById('statusbar-display');
		var status = statusbarDisplay.getAttribute('label');
		statusbarDisplay.setAttribute('label',  status + " ");
		statusbarDisplay.setAttribute('label',  status);
	}
}

function foxytunesOpenMinimode(noCheck) {
    var win = null;

    if (!noCheck || (typeof noCheck == 'undefined')) {
        win = foxytunesGetMostRecentWindow('foxytunes:minimode');
    }

    if (win) {
        if (win.gFoxyTunesMiniMode) {
            win.gFoxyTunesMiniMode.focusWindow();
        }
    } else {
       var bAlwaysOnTop = true;
       try {
         bAlwaysOnTop = gFoxyTunesPref.getBoolPref("minimode.options.alwaysontop");
       } catch (e) { }

       var features = "chrome,dialog=no,all";
       if (bAlwaysOnTop) {
            features += ',popup';
       }
       window.openDialog("chrome://foxytunes/content/minimode/minimode.xul", "_blank", features);
    }
}

/*
function foxytunesAdjustPopupPositions() {
   var mainButton = document.getElementById('foxytunes-main-menu-statusbar');
   if (!mainButton) {
        dump("Couldn't find main button + \n");
        return;
   }

   var bOpenBelow = mainButton.boxObject.screenY < 200;
   var popupIds = ['foxytunes-main-menu-popup',
                   'foxytunes-track-info-popup',
                   'foxytunes-search-web-menupopup'];
   for (var i=0; i < popupIds.length; i++) {
           var elem = document.getElementById(popupIds[i]);
           if (elem) {
                if (bOpenBelow) {
                   elem.setAttribute('position', 'after_start');
                } else {
                   elem.setAttribute('position', 'before_start');
                }
           }
   }
}
*/

function foxytunesPlayMedia(event, bURLProvided) {
    if (!foxytunesStreamIsSupportedInCurrentPlayer()) {
        foxytunesAlertStreamNotSupported();
        return;
    }
    var url = null;
    if (!bURLProvided) {
        url = gContextMenu.getLinkURL();
        url = foxytunesSanitizeURL(url);
    } else {
        url = event.target.value;
    }
    if (url) {
        foxytunesInitPlayerObjectIfNeeded();
        foxytunesShowPleaseWait(true, foxytunesGetLocaleString('pleaseWaitWhileTalkingToPlayer'));
        setTimeout(function() { foxytunesDoAndHidePleaseWait(function() { gFoxyTunesPlayerObj.PlayURIs(url); }) }, 100);
    }
    event.stopPropagation();
}

function foxytunesGetLinkDescription(elem) {
    var description = '';
    if (elem.text) {
        description = elem.text;
    } else if (elem.title) {
        description = elem.title;
    } else if (elem.hasChildNodes()) {
        for (var i=0; i < elem.childNodes.length; i++) {
            var child = elem.childNodes[i];
            if (child.localName.toLowerCase() == 'img') {
                var img = child;
                if (img.alt) {
                    description = img.alt;
                } else if (img.title) {
                    description = img.title;
                }
            }
        }
   }

   description = description.replace(/^\"/, '');
   description = description.replace(/\"$/, '');
   return description;
}

function foxytunesPopulatePageMediaMenu(event) {
    var menupopup = event.target;
    var urls = menupopup.parentNode.allPageMedia;
    var descriptions = menupopup.parentNode.allPageMediaDescriptions;
    var descriptionCount = {};
    for (var i=0; i < descriptions.length; i++) {   
        if (typeof descriptionCount[descriptions[i]] == 'undefined') {
            descriptionCount[descriptions[i]] = 1;
        } else {
            descriptionCount[descriptions[i]]++;
        }
    }

    foxytunesClearMenupopup(menupopup);
    if (urls.length > 1) {
            var playAllMenuItem = document.createElement('menuitem');
            playAllMenuItem.setAttribute('label', foxytunesGetLocaleString('pageMediaStreamAll'));
            playAllMenuItem.setAttribute('tooltiptext', foxytunesGetLocaleString('pageMediaStreamAll'));
        	var player = foxytunesTryGetFoxyTunesPlayerFromContractID(gFoxyTunesCurrentPlayerClass);
            playAllMenuItem.setAttribute('class', 'menuitem-iconic player-item'); 
          	playAllMenuItem.setAttribute('playername', player.toLowerCase());


//            playAllMenuItem.setAttribute('class', 'menuitem-iconic');
            playAllMenuItem.value = urls.join('\t');
            menupopup.appendChild(playAllMenuItem);
            var menuseparator = document.createElement('menuseparator');
            menupopup.appendChild(menuseparator);
    }

    var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                            .getService(Components.interfaces.nsIIOService);
    for (var i=0; i < urls.length; i++) {
        var url = urls[i];
        var label = null;
        var fileName = '';
        try {
            var uriObj = ioService.newURI(url, null, null);
            var urlObj = uriObj.QueryInterface(Components.interfaces.nsIURL);
            var description = descriptions[i];
            if (descriptionCount[description] > 1) {
                // we not want duplicate descriptions, just show URL
                description = '';
            }
            fileName = unescape(urlObj.fileName);
            label = description ? description : fileName;
        } catch(e) {}
        var menuitem = document.createElement('menuitem');
        if (!label) {
            label = unescape(url);           
        }
        menuitem.setAttribute('label', label);
        var tooltipText = fileName ? fileName + ' @ ' + url : url;
        menuitem.setAttribute('tooltiptext', tooltipText);
        menuitem.setAttribute('class', 'menuitem-iconic podcast-item');
        menuitem.value = url;
        menupopup.appendChild(menuitem);
    }
}

function foxytunesPopulateFeedMenu(event) {
    var target = event.target;
    var feedUI = new FoxyTunesFeedMenuPopupUI(target, target.parentNode.value);
}

function foxytunesSetElementHiddenAttrByFtpref(id) {
    var elem = document.getElementById(id);
    var key = elem.getAttribute("ftPref");
    var value = gFoxytunesPreferenceManager.getBoolPref(key, true);
    elem.hidden = (value ? false : true);
    return elem; 
}

function foxtunesGetContextMenuId(id , bInCompactMenu) {
    
    if (bInCompactMenu) {
        id = id+"-compactmenu";
    }
    return id;
}

function foxytunesShowOrHideContextMenuItems(menuIds, bForceHide, bInCompactMenu) {
    for (var i=0; i<menuIds.length; i++) {
        var currentMenuId = foxtunesGetContextMenuId(menuIds[i], bInCompactMenu);

        // if bForceHide == true - always hide the element, otherwise, set
        // visibility according to prefs
        if (!bForceHide) {
            foxytunesSetElementHiddenAttrByFtpref(currentMenuId);
        } else {
            var elem = document.getElementById(currentMenuId);
            elem.hidden = true;
        }
    }
}

function foxytunesOnContextPopupShowing(event) {
    if (event.target != event.currentTarget) {
        return;
    }

    // Do not show FoxyTunes menuitems in contextmenu if on emusic
    if (foxytunesIsInEmusic()) {
        return;
    }

    var compactMenuElem = foxytunesSetElementHiddenAttrByFtpref('foxytunes-contextmenu-compact-menu');
    var bInCompactMenu = compactMenuElem.hidden ? false : true;

    var foxytunesContextMenuIds = ['foxytunes-contextmenu-search-web',
                                   'foxytunes-contextmenu-feed-fetcher',
                                   'foxytunes-contextmenu-play-media',
                                   'foxytunes-contextmenu-play-all-media'];

    // Hide old context menu elements
    foxytunesShowOrHideContextMenuItems(foxytunesContextMenuIds, true, !bInCompactMenu);

    // Show new context menu element - according to ftpref
    foxytunesShowOrHideContextMenuItems(foxytunesContextMenuIds, false, bInCompactMenu);

    var searchTheWebMenu = document.getElementById(foxtunesGetContextMenuId('foxytunes-contextmenu-search-web', bInCompactMenu));
    if (!searchTheWebMenu) {
        return;
    }

    if (!searchTheWebMenu.hidden) {
        var searchTheWebMenuPopup = document.getElementById(foxtunesGetContextMenuId('foxytunes-contextmenu-search-web-menupopup', bInCompactMenu));
        if (!searchTheWebMenuPopup) {
            return;
        }

        var selection = foxytunesGetSelection();
        if (selection.length > 40) {
            selection = null;
        }

        // only get track data when there is no selection and we have an active controller
        var currentTrackData = !selection && gFoxyTunesPlayerObj ? foxytunesGetCurrentTrackData() : null;
        if (currentTrackData &&
            !currentTrackData.originalTitle && 
            !currentTrackData.title && 
            !currentTrackData.album && 
            !currentTrackData.artist) {
                currentTrackData = null;
        }
        if (selection) {
            var clippedSelection = foxytunesGetClippedText(selection);
            searchTheWebMenu.setAttribute('label', foxytunesGetLocaleString('musicSearchFor', ['"' + clippedSelection + '"']));
            searchTheWebMenuPopup.selection = selection;
            searchTheWebMenu.hidden = false;
        } else if (currentTrackData) {
            searchTheWebMenu.setAttribute('label', foxytunesGetLocaleString('searchNowPlaying'));
            searchTheWebMenuPopup.trackData = currentTrackData;
            searchTheWebMenu.hidden = false;
        } else {
            searchTheWebMenu.hidden = true;
        }
    } // if (!searchTheWebMenu.hidden)


    // Start Feed/Podcasts
    var feedFetcherElem = document.getElementById(foxtunesGetContextMenuId('foxytunes-contextmenu-feed-fetcher', bInCompactMenu));
    if (!feedFetcherElem.hidden) {
        var isOnFeed = false;
        var linkURL = null;
        if (gContextMenu.onLink) {
            var linkText = gContextMenu.linkText();
            linkURL = gContextMenu.getLinkURL();
            if (linkURL.match(/xml|feed|atom|rss|podcast/i)) {
                isOnFeed = true;
            } else {
                linkURL = null;
            }
        }

        if (!gContextMenu.onLink && !isOnFeed) {
            // try seeing if the page has some embedded feeds
            var feeds = gBrowser.mCurrentBrowser.feeds;
            if (feeds && (feeds.length > 0)) {
                linkURL = feeds[0].href;
            }
        }

        feedFetcherElem.hidden = (linkURL == null);
        if (linkURL) {
            feedFetcherElem.value = linkURL;
        }
    } // if (!feedFetcherElem.hidden) 
    // End Feed/Podcasts

    var supportedExtensionsRegExp = null;
    var player = foxytunesGetPlayerShortNameFromContractID(gFoxyTunesCurrentPlayerClass);
    if (player) {
        supportedExtensionsRegExp = gFTPlayerConfig.getSupportedExtensions(player);
    }

    // Start Play media
    var playMediaElem = document.getElementById(foxtunesGetContextMenuId('foxytunes-contextmenu-play-media', bInCompactMenu));
    if (!playMediaElem.hidden) {
        var focusedWindow = document.commandDispatcher.focusedWindow;
        var selection = focusedWindow.getSelection();
        var bHasSelection = selection.toString().length > 0;

        var mediaLinkURL;
        if (gContextMenu.onLink && !bHasSelection) {
            var mediaLinkText = gContextMenu.linkText();
		    var mediaLinkURL = gContextMenu.getLinkURL();
            if (!foxytunesURLIsMedia(mediaLinkURL, supportedExtensionsRegExp)) {
                mediaLinkURL = null;
            }
        }

        playMediaElem.hidden = (mediaLinkURL == null);
    }
    // End Play media

    // Start Play All media
    var playAllMediaElem = document.getElementById(foxtunesGetContextMenuId('foxytunes-contextmenu-play-all-media', bInCompactMenu));
    if (!playAllMediaElem.hidden) {
        var allPageMedia = [];
        var allPageMediaDescriptions = [];
        var UrlIndexHash = [];

        if (!gContextMenu.onLink || bHasSelection) {
            var links = gContextMenu.target ? gContextMenu.target.ownerDocument.links : [];
            for (var i=0; i < links.length && i<gFoxyTunesMaxLinksForWebMedia ; i++) { // if i got more the 1000 links - stop
                if (bHasSelection && !selection.containsNode(links[i], true)) continue;
                var url = foxytunesSanitizeURL(links[i]);
                if (url && foxytunesURLIsMedia(url, supportedExtensionsRegExp)) {
                    var description = foxytunesGetLinkDescription(links[i]);
                    if (typeof UrlIndexHash[url] == 'undefined') {
                        allPageMedia.push(url);
                        allPageMediaDescriptions.push(description);
                        // the hash contains the index of the first url entered
                        UrlIndexHash[url] = allPageMedia.length - 1;
                    } else {
                        // we already have this url
                        // see whether we want to override the previous description
                        var ind = UrlIndexHash[url];
                        var prevDescriptionLength = allPageMediaDescriptions[ind].length;
                        var currDescriptionLength = description.length;
                        if (currDescriptionLength > prevDescriptionLength) {
                            allPageMediaDescriptions[ind] = description;
                        }

                    }
                }
            }
        }

        playAllMediaElem.hidden = (allPageMedia.length == 0);
        playAllMediaElem.allPageMedia = allPageMedia;
        playAllMediaElem.allPageMediaDescriptions = allPageMediaDescriptions;
    } // if (!playAllMediaElem.hidden)
    // End Play All media

    

    var separatorElem = document.getElementById('foxytunes-contextmenu-separator');
    var bHide = searchTheWebMenu.hidden && feedFetcherElem.hidden && playMediaElem.hidden  && playAllMediaElem.hidden;
    separatorElem.hidden = bHide;
    if (bHide) {
        // if this needs to be shown, we already showed it above
        // this is only needed if we need to hide it, not due to prefs
        // but because all its children are hidden
        compactMenuElem.hidden = true;
    }
}

function foxytunesURLIsMedia(url, supportedExtensionsRegExp) {
    if (url.match(/\.mp3$/i) || url.match(/\.m3u$/i)) {
        return true;
    } else {
        if (supportedExtensionsRegExp && supportedExtensionsRegExp != "PLAY_URI_NOT_SUPPORTED") {
            var regex = new RegExp(supportedExtensionsRegExp, 'gi');
            if (regex.test(url)) return true;
        }
    }
    return false;
}

function foxytunesGetSupportedRegExp() {
    var supportedExtensionsRegExp = null;
    var player = foxytunesGetPlayerShortNameFromContractID(gFoxyTunesCurrentPlayerClass);
    if (player) {
        supportedExtensionsRegExp = gFTPlayerConfig.getSupportedExtensions(player);
    }
    return supportedExtensionsRegExp;
}

function foxytunesStreamIsSupportedInCurrentPlayer() {
    var supportedExtensionsRegExp = foxytunesGetSupportedRegExp();
    if (supportedExtensionsRegExp && supportedExtensionsRegExp == "PLAY_URI_NOT_SUPPORTED") {
        return false;
    }

    return true;
}

function foxytunesAlertStreamNotSupported() {
    foxytunesShowAlertWithDelay(window, "FoxyTunes", foxytunesGetLocaleString('playerDoesNotSupportStreaming'), 5);
}

function foxytunesOnMainMenuShowing(event, bTrayMenu) {
    if (!bTrayMenu && event.target.id != 'foxytunes-main-menu-popup') return;
    if (bTrayMenu && event.target.id != 'foxytunes-tray-main-menu-popup') return;

    // consider moving to global observer element
    var currentPlayerElem;
    if (!bTrayMenu) {
        currentPlayerElem = document.getElementById('foxytunes-player-menu');
    } else {
        currentPlayerElem = document.getElementById('foxytunes-tray-player-menu');
    }
    if (!currentPlayerElem) return;
    currentPlayerElem.removeAttribute('playername');

    if (gFoxyTunesCurrentPlayerClass) {
        var player = foxytunesTryGetFoxyTunesPlayerFromContractID(gFoxyTunesCurrentPlayerClass);
        if (player) {
            currentPlayerElem.setAttribute('playername', player.toLowerCase());
        }
    }

    var recentPlayersElem;
    if (!bTrayMenu) {
        recentPlayersElem = document.getElementById('foxytunes-recent-players-menuitem');   
    } else {
        recentPlayersElem = document.getElementById('foxytunes-tray-recent-players-menuitem');   
    }
    foxytunesPopulateRecentPlayers(recentPlayersElem);
}

function foxytunesPopulateRecentPlayers(parent) {
    var nRecent = 3;
    for (var i=0; i < nRecent; i++) {
        // we don't show icons with empty value (CSS)
        parent.getIconByIndex(i).setAttribute('value', '');
    }

    if (!gFoxyTunesRecentPlayers) {
        // hide the element (and the following separator) if there are no recent players
        parent.hidden = true;
        parent.nextSibling.hidden = true; 
        return;
    }

    parent.hidden = false;
    parent.nextSibling.hidden = false; 

    var playerArr = gFoxyTunesRecentPlayers.split(",");
    if (!playerArr || !playerArr.length) return;

    for (var i=0; i < playerArr.length; i++) {
        var iconElem = parent.getIconByIndex(i);
        if (!iconElem) break;
        var contractId = playerArr[i];
    	var player = foxytunesTryGetFoxyTunesPlayerFromContractID(contractId);
        if (!player) break;

        if (i == 0) {
            // the first player in history is also the default for the menuitem
            parent.setAttribute('value', contractId);
        }

        iconElem.setAttribute('value', contractId);
        iconElem.value = player;
        var readableName = gFTPlayerConfig.getReadableName(player.toLowerCase());         
        var label = readableName ? readableName : player;
   	 	iconElem.setAttribute('label', label);
        iconElem.setAttribute('tooltiptext', label);
       	iconElem.setAttribute('value', contractId);
       	iconElem.setAttribute('playername', player.toLowerCase());
    }
}

function foxytunesOnQuickPlayerSwitch(event) {
     var menuPopupNode = event.currentTarget;
     var menuItemNode = event.target;
     var target = event.originalTarget;
     if ((target.localName == 'menuitem') && (event.type == 'click')) {
         // on the main menuitem we will receive a 'command' event
         // so we can safely ignore this click
         return;
     }

     var player = target.getAttribute("value");

    foxytunesSelectPlayer(player);

    menuPopupNode.parentNode.hidePopup();
}

function foxytunesSeaMonkeyInstallFixer() {
    if (!foxytunesIsInMozilla()) {
        return false;
    }

   var dirServiceProp = Components.classes["@mozilla.org/file/directory_service;1"].
                            getService(Components.interfaces.nsIProperties);
   var componentsDir = dirServiceProp.get("ComsD", Components.interfaces.nsIFile);

   var mainDLLFile = componentsDir.clone();
   mainDLLFile.append('FoxyTunes.dll');

   var componentRegistrar = Components.manager.QueryInterface(Components.interfaces.nsIComponentRegistrar);
   try {
       componentRegistrar.autoRegister(mainDLLFile);
   } catch(err) {
     	dump("\nFailed autoRegistering FoxyTunes.dll\n");
    	return false; 
   }

    return true;
}

function foxytunesModuleInstallationFailed() {
   // verify that the binary xpcom components were indeed registered

   var platform = foxytunesGetPlatform();
   if ((platform == 'windows') && 
        (typeof Components.classes['@foxytunes.org/FoxyTunes/WindowsMediaPlayer;1'] == 'undefined')) {
        return true;
   }

   if ((platform == 'mac') && 
       (typeof Components.classes['@foxytunes.org/FoxyTunes/iTunes;1'] == 'undefined')) {
        return true;
   }

   if ((platform == 'linux') && 
        (typeof Components.classes['@foxytunes.org/FoxyTunes/MusicPlayerDaemon;1'] == 'undefined')) {
        return true;
   }

   return false;
}

function foxytunesShowPleaseWait(bShow, message) {
    var target = document.getElementById('foxytunes-main-menu-statusbar');
    if (!target) {
        // minibrowser (?)
        target = document.getElementById('urlbar-container');

        if (!target) return;
    } 

    var topPart = (target.boxObject.screenY < (window.screen.height/2));

    var image = document.getElementById('foxytunes-please-wait-image');
    var label = document.getElementById('foxytunes-please-wait-label');
    var player = foxytunesTryGetFoxyTunesPlayerFromContractID(gFoxyTunesCurrentPlayerClass);
    image.setAttribute('class', 'menuitem-iconic player-item'); 
    image.setAttribute('playername', player.toLowerCase());
    label.value = message;
 
    var elem = document.getElementById('foxytunes-please-wait-popup');
    if (bShow) {
        var anchor = "topleft";
        var align  = "bottomleft"
        if (topPart) {
            anchor = "bottomleft";
            align  = "topleft"   
        }
        setTimeout( function () { elem.showPopup(target, -1, -1, "popup", anchor, align); }, 50);
    } else {
        elem.hidePopup();
    }
}

function foxytunesDisableFoxyTunesMini() {
    try {
        document.getElementById('foxytunes-open-minimode-menuitem').hidden = true;
    } catch(e) { dump('error disabling mini  ' + e + '\n'); }

/*
    try {
        document.getElementById('foxytunes-open-minimode-menuseparator').hidden = true;
    } catch(e) { dump('error disabling mini  ' + e + '\n'); }
*/
}

function foxytunesDoPlatformSpecificUIChanges() {
    var platform = foxytunesGetPlatform();

	if ((platform == 'mac') || (platform == 'linux')) {
        foxytunesDisableFoxyTunesMini();
	}
}

var gFoxyTunesTrackDataObserver = {
    observe: function(subject, topic, data) {
        if (topic != "foxytunes-internal-track-data") {
            return;
        }
        switch (data) {
            case "track-title-changed-internal":
                // update track title, use cache:
                foxytunesUpdateTrackTitleLabel(true, true);
                break;
            case "track-position-changed-internal":
                // get current cached track data (has length and pos)
                var trackData = foxytunesGetCurrentTrackData(true); 
                foxytunesUpdateTrackPositionMarker(trackData.length, trackData.position);
                //dump('length: ' + trackData.length + '\n');
                //dump('pos: ' + trackData.position + '\n');
                break;
        }
    }
}
gFoxyTunesTrackDataObserver.bObserverAdded = false;

var gFoxyTunesPreferencesObserver = {
         observe : function(subject, topic, data) {
             if (topic == "nsPref:changed" && !gbFoxyTunesIgnorePrefChange) {
                 foxytunesReadPreferences();
                 if (data == "player_class") {
                     foxytunesDoPlayerSpecificUIChanges();
                 }
            }
         }
}
gFoxyTunesPreferencesObserver.bObserverAdded = false;

function foxytunesObservePrefs(bAdd) {
    var prefBranch2 = gFoxyTunesPref.QueryInterface(Components.interfaces.nsIPrefBranch2);
    if (bAdd) {
        prefBranch2.addObserver("", gFoxyTunesPreferencesObserver, false);  
        gFoxyTunesPreferencesObserver.bObserverAdded = true;
    } else {
        if (gFoxyTunesPreferencesObserver.bObserverAdded) {
            prefBranch2.removeObserver("", gFoxyTunesPreferencesObserver);  
        }
    }
}

function foxytunesObserveTrackData(bAdd) {
    var observerService = Components.classes["@mozilla.org/observer-service;1"]
                                .getService(Components.interfaces.nsIObserverService);
    if (bAdd) {
        observerService.addObserver(gFoxyTunesTrackDataObserver, "foxytunes-internal-track-data", false);
        gFoxyTunesTrackDataObserver.bObserverAdded = true;
    } else {
        if (gFoxyTunesTrackDataObserver.bObserverAdded) {
            observerService.removeObserver(gFoxyTunesTrackDataObserver, "foxytunes-internal-track-data");
        }
    }
}

var gFoxyTunesSwitchPlayerObserver = {
    observe: function(subject, topic, data) {
        if (topic != "foxytunes-internal-switch-player") {
            return;
        }
        
        foxytunesSelectPlayer(data); 

        var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"]
                    .getService(Components.interfaces.nsIWindowMediator);
        var topWin = windowMediator.getMostRecentWindow('navigator:browser');
        if (!topWin) {
            topWin = windowMediator.getMostRecentWindow('foxytunes:minibrowser');
        }

        
        // Show tooltip only if the current window is not minimized and is the topmost window
        if (topWin != window) return;
        var mainWin = document.getElementById('main-window');
        if (!mainWin) return;
        if ((mainWin.boxObject.screenX < 0) && (mainWin.boxObject.screenY < 0)) return;
        
        var player = foxytunesTryGetFoxyTunesPlayerFromContractID(data);
        var readableName = gFTPlayerConfig.getReadableName(player.toLowerCase());   
        var label = readableName ? readableName : player;
        foxytunesShowPleaseWait(true, 'Switching player to ' + label);
        setTimeout(function() { foxytunesShowPleaseWait(false); }, 5000);
        foxytunesUpdateTrackTitleAfterCommand();
    }
}

gFoxyTunesSwitchPlayerObserver.bObserverAdded = false;

function foxytunesObserveSwitchPlayer(bAdd) {
    var observerService = Components.classes["@mozilla.org/observer-service;1"]
                                .getService(Components.interfaces.nsIObserverService);
    if (bAdd) {
        observerService.addObserver(gFoxyTunesSwitchPlayerObserver, "foxytunes-internal-switch-player", false);
        gFoxyTunesSwitchPlayerObserver.bObserverAdded = true;
    } else {
        if (gFoxyTunesSwitchPlayerObserver.bObserverAdded) {
            observerService.removeObserver(gFoxyTunesSwitchPlayerObserver, "foxytunes-internal-switch-player");
        }
    }
}


function foxytunesObserveContextMenu(bAdd) {
   var contextMenu = document.getElementById("contentAreaContextMenu");
   if (contextMenu) {
       if (bAdd) {
           contextMenu.addEventListener("popupshowing", foxytunesOnContextPopupShowing, false);
           var appName = foxytunesGetAppName();
           switch (appName) {
                case "firefox":
                    var version = foxytunesGetAppVersion();
                    if (!version || (version && (version.charAt(0) < 2))) {
                        contextMenu.addEventListener('mouseover', foxytunesCloseLastContextMenu, false);
                    }
                    break;
                default:
                    contextMenu.addEventListener('mouseover', foxytunesCloseLastContextMenu, false);
           }
       }
   }
}
function foxytunesInitMinibrowserOverlay() {
    try {
        foxytunesReadPreferences();
        foxytunesObserveContextMenu(true);
        foxytunesObservePrefs(true);
        foxytunesInitPlayerObjectIfNeeded(false);
    } catch(err) {
        dump("Fatal error initializing FoxyTunes MiniBrowser: " + err + "\n");
    }
}

function foxytunesCustomizeWebSearchEngine() {
    window.open('chrome://foxytunes/content/search/foxytunesCustomWebSearchEngine.xul', '', 'chrome,centerscreen,modal');
}

function foxytunesClearQuickSwitch() {
    gFoxyTunesPref.setCharPref("recent_players", "");
}

function foxytunesUpdateFoxytunesVersionAndShowWelcomeScreenIfNeeded() {

   var bShowWelcomeScreen = false;

   var foxytunesPrevVersion    = foxytunesReadSinglePreference('version', 'fresh-installation');
   var foxytunesCurrentVersion = foxytunesGetFoxyTunesVersion(); 

   // Problem getting the currnet version - should we show welcome screen?
   if (!foxytunesCurrentVersion || !foxytunesPrevVersion) {
        return;
   }

   if ((foxytunesPrevVersion == 'fresh-installation') || 
       (foxytunesPrevVersion != foxytunesCurrentVersion)) {
        bShowWelcomeScreen = true;
        foxytunesWriteSinglePreference('version', foxytunesCurrentVersion);
   } 

   // Do not show welcome screen
   var noWelcomeScreen = gFoxytunesPreferenceManager.getBoolPref('no_welcome_screen', false);
   if (noWelcomeScreen) return;
    
   if (bShowWelcomeScreen) {
        var appName = foxytunesGetAppName();
        if (!appName || (appName == 'unknown')) {
            appName = '-';
        }
        var appVersion = foxytunesGetAppVersion();
        if (!appVersion) {
            appVersion = "-";
        }

        if (foxytunesPrevVersion == 'fresh-installation') {
            foxytunesPrevVersion = '-';
        }

        var url = 'http://www.foxytunes.com/welcome/' + 
                            appName + '/' + 
                            appVersion + '/' + 
                            foxytunesPrevVersion + '/' + 
                            foxytunesCurrentVersion;

        if (!foxytunesIsInThunderbird()) {
            // do not show welcome screen in thunderbird
            foxytunesGoToURL(url, true);
        }
   }
}

function foxytunesUninstallObserver() {
    this._observerService = Components.classes["@mozilla.org/observer-service;1"]
                                .getService(Components.interfaces.nsIObserverService);
    this._observerService.addObserver(this, "em-action-requested", false);
    this._guid = '{463F6CA5-EE3C-4be1-B7E6-7FEE11953374}';

    var appName = foxytunesGetAppName();
    if (!appName || (appName == 'unknown')) {
           appName = '-';
    }

    var appVersion = foxytunesGetAppVersion();
    if (!appVersion) {
        appVersion = "-";
    }
    var ftVersion = foxytunesGetFoxyTunesVersion();
    if (!ftVersion) {
        ftVersion = "-";
    }
    this._uninstallURL = "http://www.foxytunes.com/uninstall/";
    this._uninstallURL += appName + "/";
    this._uninstallURL += appVersion + "/";
    this._uninstallURL += ftVersion + "/";

    // we need the following preference to prevent several observers
    // in several open firefox windows to launch the uninstall screen
    // the first observer to launch the screen sets the flag to 'true'
    // the flag is reseted by each new observer, because the event
    // can only happen once
    foxytunesWriteSinglePreference('uninstall_screen_shown', 'false');
}

foxytunesUninstallObserver.prototype = {
    observe: function(subject, topic, data) {
        if ((topic == "em-action-requested") && 
            (data == "item-uninstalled")) {

            var bUninstallScreenShown = foxytunesReadSinglePreference('uninstall_screen_shown', 'false');
            if (bUninstallScreenShown == 'true') return;

            var updateItem = subject.QueryInterface(Components.interfaces.nsIUpdateItem);
            if (updateItem.id == this._guid) {
                   foxytunesWriteSinglePreference('uninstall_screen_shown', 'true');
                   foxytunesGoToURL(this._uninstallURL, true);
                   if (foxytunesIsInFirefox()) {
                    var extraUtils = new ExtraUtils['1.1']; 
                    extraUtils.removeExtensionFromAddRemove("FoxyTunesForFirefox");
                   }
            } 
        }
    },

    removeObserver : function() {
        this._observerService.removeObserver(this, "em-action-requested");
        }
}

function foxytunesShowStatusBarUponFreshInstall() {
    var foxytunesPrevVersion = foxytunesReadSinglePreference('version', 'fresh-installation');
    if (foxytunesPrevVersion == 'fresh-installation') {
        var statusBar = document.getElementById('status-bar');
        if (statusBar && statusBar.hidden) {
            setTimeout(function () {try {goToggleToolbar('status-bar','toggle_taskbar');} catch (e) {}}, 100);
        }
    }
}

function foxytunesInitOverlay() {
 try {

   if (foxytunesIsInFirefox()) {
       var extraUtils = new ExtraUtils['1.1']; 
       extraUtils.addExtensionToAddRemove('FoxyTunesForFirefox', 'FoxyTunes for Firefox', 'foxytunes');
   }

   setTimeout(function() {foxytunesUpdateFoxytunesVersionAndShowWelcomeScreenIfNeeded() }, 400);

   try {
       gFoxytunesSignatures = new FoxytunesSignatures();
       gFoxytunesSignatures.init();
   } catch (e) {};

   try {
       gFoxytunesYMPPageAnalyzer = new FoxytunesYMPPageAnalyzer();
       gFoxytunesYMPPageAnalyzer.init();
       var bAddMediaPlayerToPage = gFoxytunesPreferenceManager.getBoolPref('add_media_player_to_page', 'true');
       document.getElementById('foxytunes-add-media-player-to-page').setAttribute('checked', bAddMediaPlayerToPage);
   } catch (e) {};

   if (foxytunesWindowIsMinibrowser(window)) {
        foxytunesInitMinibrowserOverlay();
        return;
   }

   try {
       if (!foxytunesIsInMinimode()) {
    	   foxytunesInitKeyboardShortcuts();
       }
   } catch(err) {
	   // let's assume that shortcut related problems are non-critical
	   dump("Error initializing shortcuts " + err + "\n");
   }

   // proceed even if the failed upgrade detected, the user works with the old version 
   foxytunesReadPreferences();

   foxytunesInstallPlatformSpecificLibraryIfNeeded();

   foxytunesPopulateCharacterEncodings();
   var nPlayers = foxytunesPopulatePlayers();
   if ((nPlayers == 0) && (foxytunesIsInMozilla())) {
        foxytunesSeaMonkeyInstallFixer();
        nPlayers = foxytunesPopulatePlayers();
   }

   foxytunesPopulateRecentCharsets();
   foxytunesInitVolumeSlider();

   if ((nPlayers == 0) || foxytunesModuleInstallationFailed())  {
	foxytunesInsertPlayersMenuItem('noPlayerModulesFound');
   }

   if (!foxytunesIsInMinimode()) {
       // the following will re-install listeners (volume slider...):	
       foxytunesSetFoxyTunesPosition();
   }

   foxytunesThunderbirdSpecificInit();
   foxytunesSeaMonkeySpecificInit();
   foxytunesEmusicSpecificInit();

   foxytunesInitTrackTitleLabel();

   if (!foxytunesIsInMinimode()) {
           // make sure FoxyTunes doesn't cause width overflows in the browser window:
           if (window.toolbar.visible) {
               // make sure FoxyTunes doesn't cause width overflows in the browser window:
               foxytunesVerifyWidth();
               addEventListener("resize", foxytunesVerifyWidth, false);
           } else {
               var foxyTunes = document.getElementById('foxytunes-statusbar-panel');
	
               foxyTunes.setAttribute('hidden', 'true');	
               function restoreInPopup() {
                    foxyTunes.setAttribute('hidden', 'false');	
                    foxytunesVerifyWidth();
                    addEventListener("resize", foxytunesVerifyWidth, false);
               }

            // delay appearance in popups, so we don't mess their width
               setTimeout(restoreInPopup, 500);       
           }
    }

   // hide FoxyTunes when the status display label is cropped and shift is pressed:
   if (!foxytunesIsInMinimode() &&
       !foxytunesIsInThunderbird() && 
		(foxytunesReadSinglePreference('statusbar_reveal_disabled', 'false') != 'true'))  {
	var statusbarDisplay = document.getElementById('statusbar-display');
	statusbarDisplay.addEventListener("DOMAttrModified", foxytunesOnBrowserStatusChanged, false);   
	addEventListener("mousemove", foxytunesOnMouseMove, false);
   }
   
   // adjust popup positions (above or below), boxObject needs this to be delayed
   //   setTimeout(foxytunesAdjustPopupPositions, 200);

   foxytunesObserveContextMenu(true);

   foxytunesDoPlayerSpecificUIChanges();
   foxytunesDoPlatformSpecificUIChanges();

   foxytunesShowUpdateAvailableButtonIfNeeded();

   foxytunesObservePrefs(true);
   foxytunesObserveTrackData(true);
   foxytunesObserveSwitchPlayer(true);

   if (foxytunesIsInMinimode()) {
      // the following is needed for the minibrowser (fixes browser.js which accesses window.opener)
      window.gFindMode = null;
   }

   if (!foxytunesIsInMinimode() && !foxytunesIsInThunderbird()) {
        foxytunesShowStatusBarUponFreshInstall();
   }

 } catch(err) {
   dump("Fatal error initializing FoxyTunes: " + err + "\n");
 }
}

function foxytunesUninitOverlay() {
   foxytunesObserveTrackData(false);
   foxytunesObserveSwitchPlayer(false);
   foxytunesObservePrefs(false);
   gFoxyTunesUninstallObserver.removeObserver();
   try {
     gFoxytunesSignatures.unInit();
   } catch (e) {};
   try {
     gFoxytunesYMPPageAnalyzer.unInit();
   } catch (e) {};
}

function foxytunesOpenTwittyTunesDialog() {
    var twittyTunesVersion = foxytunesGetExtensionVersion('twittytunes@extras.foxytunes.com');
    if (twittyTunesVersion) {
        var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].
                                getService(Components.interfaces.nsIPromptService);
        var text = foxytunesGetLocaleString('twittytunesAlreadyInstalled');
        promptService.alert(null, 'FoxyTunes', text);
    } else {
        var params = "centerscreen,chrome,dialog,dependent";
        window.openDialog("chrome://foxytunes/content/extras/getTwittyTunes.xul", "_blank", params);
    }
}

function foxytunesInstallTwittyTunes() {
    var extensionInstaller = new ExtensionInstaller['1.0'];
    var text = foxytunesGetLocaleString('installing', [ 'TwittyTunes' ]);
    extensionInstaller.installFromURL('http://downloads.foxytunes.com/firefox/extras/TwittyTunes_latest.xpi', text);
}        

function foxytunesSetAmazonStore(event) {
    var country = event.target.getAttribute('value');
    try {
        gFoxyTunesPref.setCharPref("amazon.country", country);
    } catch (err) {
        dump("\nSetting preference for amazon store failed: " + err + "\n");
    }
    
}

function foxytunesSetAmazonStoreOption(event) {
    var target = event.target;
    var country = "USA"
    try {
            country = gFoxyTunesPref.getCharPref("amazon.country");
    } catch (err) {
        dump("\nSetting preference for amazon store failed: " + err + "\n");
    }
     
    for (var i=0; i < target.childNodes.length; i++) {
        if (target.childNodes[i].getAttribute('value') == country) {
            target.childNodes[i].setAttribute('checked', 'true');
            break;
        }
    }
}

function foxytunesGenarateUrlsFromFileOrDirectory(urls, fileOrDir , supportedExtensionsRegExp) {
    var file = fileOrDir;  

    if (!file) {
        return "";
    }
    var charset = null;
    if (gFoxytunesUtils) {
        charset = gFoxytunesUtils.GetCurrentCharset();
    } else {
        charset = "UTF-8";
    }

    if (urls.length > foxytunesDragAndDropObserver.maxItemSupported) {
        return "FT_EXCEEDED_MAX_ELEMENTS";
    }
    if (file.isFile()) {
        if (file.exists() && foxytunesURLIsMedia(file.path, supportedExtensionsRegExp)) {
            var path;
            if (charset) {
                gFoxyTunesUnicodeConverter.charset = charset;
                path = gFoxyTunesUnicodeConverter.ConvertFromUnicode(file.path);
            } else {
                path = file.path;
            }
            urls.push("file:///" + path);
        }
    } else if (file.isDirectory ()) {
        var entries = file.directoryEntries;
        var array = [];
        while(entries.hasMoreElements()) {
            var entry = entries.getNext();
            entry = entry.QueryInterface(Components.interfaces.nsIFile);
            var rc = foxytunesGenarateUrlsFromFileOrDirectory(urls, entry , supportedExtensionsRegExp);
            if (rc == "FT_EXCEEDED_MAX_ELEMENTS") {
                return "FT_EXCEEDED_MAX_ELEMENTS";
            }
        }
    }
    return "";
}

function foxytunesGenarateUrlsFromUrl(urls, url , supportedExtensionsRegExp) {

    if (!url) {
        return;
    }
    if (foxytunesURLIsMedia(url, supportedExtensionsRegExp)) {
        urls.push(foxytunesSanitizeURL(url));
    }

    return;
}

var foxytunesDragAndDropObserver = {
  canHandleMultipleItems: true,
  getSupportedFlavours : function () {
    var flavours = new FlavourSet();
    flavours.appendFlavour('application/x-moz-file','nsIFile');
    flavours.appendFlavour("text/x-moz-url");
    return flavours;
  },

  onDragOver: function (evt,flavour,session){},

  onDrop: function (evt,dropdata,session){

    var dataList = dropdata.dataList;
    
    if (!foxytunesStreamIsSupportedInCurrentPlayer())  {
        foxytunesAlertStreamNotSupported();
        return;
    }

    if (!this.maxItemSupported) {
        this.maxItemSupported = foxytunesReadSinglePreference("dnd_max_items", 1000);
    }

    var supportedExtensionsRegExp = foxytunesGetSupportedRegExp();
    var urls = [];
    for (var i = 0; i < session.numDropItems; i++) 
    {
        var item = dataList[i].first;
        var type = item.flavour.contentType;
        var rc;

        switch(type)
    	{
	        case "application/x-moz-file":
                var fileOrDir = item.data;
                rc = foxytunesGenarateUrlsFromFileOrDirectory(urls, fileOrDir, supportedExtensionsRegExp);
                break;

            case "text/x-moz-url":
                var link = item.data;

                var lcPath = link.toLowerCase();
                var ios = Components.classes["@mozilla.org/network/io-service;1"]
                    .getService(Components.interfaces.nsIIOService);
                var fileHandler = ios.getProtocolHandler("file")
                     .QueryInterface( Components.interfaces.nsIFileProtocolHandler);
                var fileOrDir = null;
                // checking if the url is a local file
                if (lcPath.indexOf("file:") == 0 ) {
                var separator = link.indexOf(",");
                    if (separator != -1)   {
                            link = link.substr(0,separator);
                    }
                    fileOrDir = fileHandler.getFileFromURLSpec (link);
                    rc = foxytunesGenarateUrlsFromFileOrDirectory(urls, fileOrDir, supportedExtensionsRegExp);
                } else {
                    // the link data is reveived as "LINK_URL\nLINK_TITLE"
                    var separator = link.indexOf("\n");
                    if (separator != -1)   {
                        link = link.substr(0,separator);
                    }
                    rc = foxytunesGenarateUrlsFromUrl(urls, link , supportedExtensionsRegExp);
                }
                break;

            default:
                dump("Unkown drop type: " + type + "\n");
                return;
        }

        if (rc == "FT_EXCEEDED_MAX_ELEMENTS") {
            break;
        }
    }

    if (urls.length > 0) {
        var urlsList = urls.join('\t');
        foxytunesInitPlayerObjectIfNeeded();
        foxytunesShowPleaseWait(true, foxytunesGetLocaleString('pleaseWaitWhileTalkingToPlayer'));
        setTimeout(function() { foxytunesDoAndHidePleaseWait(function() { gFoxyTunesPlayerObj.PlayURIs(urlsList); }) }, 100);
    }
  }
};

addEventListener("load", foxytunesInitOverlay, false);
addEventListener("unload", foxytunesUninitOverlay, false);

// preferences:
var gFoxyTunesPrefService = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService);
var gFoxyTunesPref = gFoxyTunesPrefService.getBranch("foxytunes."); 

// unicode converter:
var foxytunesScriptableUnicodeConverter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"].getService();
var gFoxyTunesUnicodeConverter = foxytunesScriptableUnicodeConverter.QueryInterface(
				         Components.interfaces.nsIScriptableUnicodeConverter);

var gFoxytunesUtils = null;
const kUtilsCID = "@foxytunes.org/FoxyTunesEngine/FoxyTunesUtils;1";
if (typeof Components.classes[kUtilsCID] != 'undefined') {
    gFoxytunesUtils = Components.classes[kUtilsCID]
                .getService(Components.interfaces.IFoxyTunesUtils);        
}

// current charater encoding for the media information:
//var gFoxyTunesCharacterEncoding = 'default';
var gFoxyTunesCharacterEncoding;

// track info display timer ID:
var gFoxyTunesTrackInfoTimerID = 0;

// playing global flag - if track info tooltip is displayed and not playing, stop the timer:
var gbFoxyTunesPlaying = false;

// changing slider position global flag, if set, then changing the curpos property won't cause SetVolume
var gbFoxyTunesChangingSliderPos = false;

// array of menuitems of all available charsets 
var gFoxyTunesAllCharSets; 

// list of the recent charsets (loaded from pref)
var gFoxyTunesRecentCharsets;

// maximal number of recent charsets:
var gFoxyTunesMaxRecentCharsets;

// custom player options string:
var gFoxyTunesCustomPlayerOptions;

// current player options string:
var gFoxyTunesCurrentPlayerOptions;

// whether to open windows in tabs (as opposed to new windows):
var gbFoxyTunesOpenWindowInTab = true;

// the id of the DOM element to position FoxyTunes at:
var gFoxyTunesParentElementID = '';

// the id of the DOM element to insert FoxyTunes before
// if equals to the parent ID, insert as the last child:
var gFoxyTunesInsertBeforeElementId = '';

// if the insert before fails, try inserting after this one:
var gFoxyTunesInsertAfterElementId = '';

// current class name (contract ID) for the player XPCOM object:
var gFoxyTunesCurrentPlayerClass;

// the player controller object:
var gFoxyTunesPlayerObj = null;

// this will cache the size of the track info tooltip
// solves a positioning problem - we do not know the height
// before the first popup. After the first popup it is queried and cached
var gFoxyTunesTrackInfoTooltipHeight = 0;

// cached current track title from the last query to the player:
var gFoxyTunesCurrentTrackTitle = null;

// time ID for auto-hide:
var gFoxyTunesAllButtonsAutohideTimerID = 0;

// auto hide timeout:
var gFoxyTunesAutoHideTimeout = 1000;

// max links to parse in page for web Media
var gFoxyTunesMaxLinksForWebMedia = 1000;

// don't update track title on prev/next/play
var gbFoxyTunesDontUpdateTitleOnCommand = false;

// update track title on prev/next/play timeout
var gFoxyTunesUpdateTitleOnCommandTimerID = 0;

// override the regular track title popup (show a regular tooltip)
var gbFoxyTunesNoTitlePopup = false;

// monitors the shift key state
var gbFoxyTunesShiftDown = false;

// URL unescape titles
var gbURLUnescape = false;

// DOM parser
var gFoxyTunesDOMParser	= Components.classes["@mozilla.org/xmlextras/domparser;1"].
							createInstance(Components.interfaces.nsIDOMParser);

// Is the info popup visible?
var gbFoxyTunesInfoPopupVisible = false;

// Last infobox window
var gbFoxyTunesInfoBoxWindowOpened = false;
var gFoxyTunesInfoBoxWindow = null;
var gFoxyTunesInfoBoxHideTimerId = null;
var gFoxyTunesInfoBoxShowTimerId = null;

// a list of recently used players
var gFoxyTunesRecentPlayers = "";

// Ignore preference change to prevent our own writes triggering the observer
var gbFoxyTunesIgnorePrefChange = false;

// Start uninstall observer 
var gFoxyTunesUninstallObserver = new foxytunesUninstallObserver();

// Signatunes
var gFoxytunesSignatures = null;
