function FoxyTunesTooltipInfo() {
    this.text = null;
    this.learnMoreLink = null;
    this.position = 'right';
    this.showOnce = false;
    this.persistOnRefersh = false;
    this.topOffset = 0;
    this.leftOffset = 0;
    this.id = 'foxytunes-html-tooltip';
}

function FoxyTunesHTMLTooltip() {
    this.tooltipWidth = 283;
    this.tooltipHeight = 105;
    this.fontSize = 13;
    this.tipOffset = 25;
}

FoxyTunesHTMLTooltip.prototype = {
    closeTooltip: function(doc, tooltipInfo) {
        var tooltipId = tooltipInfo.id;
        if (tooltipInfo.showOnce) {
            foxytunesWriteSinglePreference('html-tooltip.' + tooltipId + '.displayed', 'true');
        }

        var tooltip = doc.getElementById(tooltipId);
        if (!tooltip) return;

        tooltip.parentNode.removeChild(tooltip);
    },

    showTooltip: function(doc, elem, tooltipInfo) {
        if (tooltipInfo.showOnce && 
            (foxytunesReadSinglePreference('html-tooltip.' + tooltipInfo.id + '.displayed', 'false') == 'true')) {
            return;
        }

        // don't show ballon twice
        if (doc.getElementById(tooltipInfo.id)) return;

        var tooltip = doc.createElement('div');
        tooltip.setAttribute('id', tooltipInfo.id);
        if (tooltipInfo.position == 'right') {
            tooltip.style.backgroundImage = "url(chrome://foxytunes-public/content/html-tooltip/html-tooltip-right.png)"
        } else {
            tooltip.style.backgroundImage = "url(chrome://foxytunes-public/content/html-tooltip/html-tooltip-left.png)"
        }
        tooltip.style.display  = 'block';
        tooltip.style.visibility  = 'visible';
        tooltip.style.position = 'fixed';
        tooltip.style.zIndex = 1000;
        tooltip.style.width = this.tooltipWidth + 'px';
        tooltip.style.height = this.tooltipHeight + 'px';    
        tooltip.style.fontSize = this.fontSize + 'px';    
        
        var elemTop = doc.defaultView.getComputedStyle(elem, "").getPropertyValue("top").substr(0, elem.style.top.length - 2);
        var elemLeft = doc.defaultView.getComputedStyle(elem, "").getPropertyValue("left").substr(0, elem.style.top.length - 2);
        var elemWidth = doc.defaultView.getComputedStyle(elem, "").getPropertyValue("width").substr(0, elem.style.top.length - 2);

        elemTop = parseInt(elemTop);
        elemLeft = parseInt(elemLeft);
        elemWidth = parseInt(elemWidth);

      //  dump("elemTop: " + elemTop + ", elemLeft: " + elemLeft + ", elemWidth: " + elemWidth + "\n");

        var top = elemTop - this.tooltipHeight + tooltipInfo.topOffset;
        var left;
        if (tooltipInfo.position == 'right') {
            left = elemLeft - this.tooltipWidth + this.tipOffset;
        } else {
            left = elemLeft + elemWidth - this.tipOffset;
        }
        left = left + tooltipInfo.leftOffset;
        top = (top < 0) ? 0 : top;
        left = (left < 0) ? 0 : left;

        tooltip.style.top = top + 'px';
        tooltip.style.left = left + 'px'; 

        var learnMore = foxytunesGetLocaleString('learnMore');
        var innerHTML = '<table style="color:black; background-color: transparent; width: 283px; height: 80px;"><tr style="background-color: transparent;">' +
                        '<td valign="middle" style="color:black; background-color: transparent;font-size: 12px;font-family: arial; padding-left: 40px; padding-right: 25px;">' + tooltipInfo.text;
        if (tooltipInfo.learnMoreLink) {
            innerHTML += ' <a style="color:blue" target="_blank" href="' + tooltipInfo.learnMoreLink + '">' + learnMore + '</a>';
        }
        innerHTML += '</td></tr></table>';
        tooltip.innerHTML = innerHTML; 

        elem.parentNode.insertBefore(tooltip, elem);

        var me = this;
        tooltip.addEventListener('click', function() { me.closeTooltip(doc, tooltipInfo); }, false);

        if (tooltipInfo.showOnce && !tooltipInfo.persistOnRefersh) {
            foxytunesWriteSinglePreference('html-tooltip.' + tooltipInfo.id + '.displayed', 'true');
        }
    }
}
